
// File id: GSets



var gChordToRef = [0, 1, 2, 15, 3, 27, 19, 46, 4, 42, 36,
                        16, 33, 28, 20, 47, 5, 35, 59, 17, 32, 29, 21, 48, 7, 8, 9, 44, 10,
                        41, 38, 56, 6, 34, 31, 18, 43, 30, 22, 49, 23, 24, 25, 58, 26, 60,
                        40, 62, 11, 12, 13, 37, 14, 39, 45, 63, 50, 51, 52, 54, 53, 55, 57,
                        61];

var GKOSGraphs = [ //
                  "", "", "", "", "", "", "", "", "", "",
                  "", "", "", "", "", "", "", "", "", "",
                  "", "", "", "", "", "", "", "", "", "",
                  "", "", "", "", "", "", "", "", "", "", "", "",
        "images/ups.png", // _Up
        "images/downs.png", // _Down
        "", // _PgUp
        "", // _PgDn
        "images/backspace2ssEdges.png", // _BS
        "images/wlefts.png", // _WLeft
        "images/lefts.png", // _Left
        "images/homes.png", // _Home
        "images/spacessEdges.png", // _SP
        "images/wrights.png", // _WRight
        "images/rights.png", // _Right
        "images/ends.png", // _End
        "", // "images/enters.png", // _Enter (No graph in this verstion, just text 'Enter' on the key
        "", // "images/tabs.png", // _Tab (No graph...)
        "", // _Esc
        "", // _Del
        "", // _Ins
        "images/shifts.png", // _Shift
        "", // "../../images/symbs.png", // _SYMB
        "images/abcnum2sEdges.png", // _123abc
        "", // _Ctrl
        "", // _Alt
    ]


var GKOSChars = [
                "",
                "a", "b", "c", "d", "e", "f",
                "g", "h", "i", "j",
                "k", "l", "m", "n",
                "o", "p", "q", "r",
                "s", "t", "u", "v",
                "w", "x", "y", "z",
                "th", "that ", "the ", "of ",
                ".",
                ",",
                "!",
                "?",
                "-",
                "'",
                "\\",
                "/",
                "and ",
                "with ",
                "to ",
                "_Up",
                "_Down",
                "_PgUp",
                "_PgDn",
                "_BS",
                "_WLeft",
                "_Left",
                "_Home",
                " ",
                "_WRight",
                "_Right",
                "_End",
                "_Enter",
                "_Tab",
                "_Esc",
                "_Del",
                "_Ins",
                "_Shift",
                "_SYMB",
                "_123abc",
                "_Ctrl",
                "_Alt",
                // SHIFT: 64-127
                // Activated by Shift (Shift = B+E)(only impacts on a single
                // character)
                "",
                "A", "B", "C", "D", "E", "F",
                "G", "H", "I", "J",
                "K", "L", "M", "N",
                "O", "P", "Q", "R",
                "S", "T", "U", "V",
                "W", "X", "Y", "Z",
                "Th", "That ", "The ", "Of ",
                ":",
                ";",
                "|",
                "~",
                "_",
                "\"",
                "\u0300", //  \u0300, eri kuin: "`"
                "\u0301", //  \u0301, eri kuin: "´"
                "And ",
                "With ",
                "To ",
                "_Up",
                "_Down",
                "_PgUp",
                "_PgDn",
                "_BS",
                "_WLeft",
                "_Left",
                "_Home",
                " ",
                "_WRight",
                "_Right",
                "_End",
                "_Enter",
                "_Tab",
                "_Esc",
                "_Del",
                "_Ins", // "\u00b0" = degree sign (only by SYMB + Insert now)
                "_Shift",
                "_SYMB",
                "_123abc",
                "_Ctrl",
                "_Alt",
                // CAPS: 128-191
                // Activated by double Shift (Shift = B+E)
                "",
                "A", "B", "C", "D", "E", "F",
                "G", "H", "I", "J",
                "K", "L", "M", "N",
                "O", "P", "Q", "R",
                "S", "T", "U", "V",
                "W", "X", "Y", "Z",
                "TH", "THAT ", "THE ", "OF ",
                ".",
                ",",
                "!",
                "?",
                "-",
                "'",
                "\\",
                "/",
                "AND ",
                "WITH ",
                "TO ",
                "_Up",
                "_Down",
                "_PgUp",
                "_PgDn",
                "_BS",
                "_WLeft",
                "_Left",
                "_Home",
                " ",
                "_WRight",
                "_Right",
                "_End",
                "_Enter",
                "_Tab",
                "_Esc",
                "_Del",
                "_Ins",
                "_Shift",
                "_SYMB",
                "_123abc",
                "_Ctrl",
                "_Alt",
                // NUMS: 192-255
                // Activated by abc123 = SPACE+BACKSPACE (impacts on characters until pressed
                // again)
                "",
                "1", "2", "3", "4", "5", "6",
                "0", "7", "8", "9",
                "@", "#", "\u00bd", "&",
                "+", "%", "=", "^",
                "*", "$", "\u20ac",	"\u00a3",
                "(", "[", "<", "{",
                ")", "]", ">", "}",
                ".",
                ",",
                "!",
                "?",
                "-",
                "'",
                "\\",
                "/",
                "\u00b5", // (and ) �
                "\u00a7", // (with ) �
                "\u00b0", // degree sign //  02C7 = separate caron, (to ) "\u030c" = combining caron
                "_Up", "_Down", "_PgUp", "_PgDn", "_BS", "_WLeft", "_Left",
                "_Home", " ", "_WRight", "_Right",
                "_End",
                "_Enter",
                "_Tab",
                "_Esc",
                "_Del",
                "_Ins",
                "_Shift",
                "_SYMB",
                "_123abc",
                "_Ctrl",
                "_Alt",
                // SYMB: 256-319
                // Activated by TH+W (only impacts on a single character)
                "",
                "1", "2", "3", "4", "5", "6",
                "0", "7", "8", "9",
                "@", "#", "\u00bd", "&",
                "+", "%", "=", "^",
                "*", "$", "\u20ac", "\u00a3",
                "(", "[", "<", "{",
                ")", "]", ">", "}",
                ":",
                ";",
                "|",
                "~",
                "_",
                "\"",
                "`", // was \u0300
                "´", // was \u0301
                "\u00a8", // "\u0308"; // combining diaresis ( ̈ )
                "\u00a7", // clause, section
                "\u02C7", // = separate caron, "\u030c" = combining, // "\u030c"; //
                // combining caron (v on top) ( ̌ )
                // "\u005e", // circumflex accent (inverted v on top)
                // Html.fromHtml("&#728;").toString(), // breve instead
                "_Up", "_Down", "_PgUp", "_PgDn", "_BS", "_Left", "_WLeft",
                "_Home", " ", "_Right", "_WRight", "_End", "_Enter", "_Tab",
                "_Esc", "_Del", "\u00b0", // degree sign
                "_Shift", "_SYMB", "_123abc", "_Ctrl", "_Alt",

// AuxSet1 abc (Lower case, 'aux')

// AUXSET: 320-383 (Here initialized same as abc = lower case basic English set)
// To be activated by Shift in NUM mode
// - Now only used in special cases like Korean basic Hangul Jamos
                //
                "",
                "a", "b", "c", "d", "e", "f", // a-f
                "g", "the ", "i", "j", // g
                "k", "l", "m", "n", // k
                "o", "p", "q", "r", // o
                "s", "t", "u", "v", // s
                "w", "x", "y", "z", // w
                "d", "I ", "that ", "you ", // th
                ".", ",", "!", "?", "-", "'", "\\", "/", "don't ", "wh", "th",
                "_Up",
                "_Down",
                "_PgUp",
                "_PgDn",
                "_BS",
                "_WLeft",
                "_Left",
                "_Home",
                " ",
                "_WRight",
                "_Right",
                "_End",
                "_Enter",
                "_Tab",
                "_Esc",
                "_Del",
                "_Ins",
                "_Shift",
                "_SYMB",
                "_123abc",
                "_Ctrl",
                "_Alt",

// AuxSet2 Abc (Shift, 'Aux')

// *AUXSET2*: 384-447 (TODO: Here initialized the same as Abc = Upper case basic English set)
// To be activated by Shift while in AUXSET
// - Now only used in special cases like Korean double tail consonants
                "",
                "\u263a", "\u263b", "\u2639", "d", "e", "f", // a-f
                "☏", "The ", "☆", "☎", // g
                "♩", "♪", "♫", "♬", // k
                "o", "♥", "♡", "∞", // o
                "♞", "♀", "♂", "♨", // s
                "w", "\u00ab", "《", "z", // w
                "D", "I'm ", "That ", "You ", // th
                ":", ";", "|", "~", "_", "\"", "\u0300", "\u0301", "Don't ", "Wh", "Th",
                "_Up",
                "_Down",
                "_PgUp",
                "_PgDn",
                "_BS",
                "_WLeft",
                "_Left",
                "_Home",
                " ",
                "_WRight",
                "_Right",
                "_End",
                "_Enter",
                "_Tab",
                "_Esc",
                "_Del",
                "_Ins",
                "_Shift",
                "_SYMB",
                "_123abc",
                "_Ctrl",
                "_Alt",


// AuxSet3 ABC (Caps, 'AUX')

                // *AUXSET3*: 448 - 511 (Here initialized the same as ABC = CAPS basic English set)

                "",
                "A", "B", "C", "D", "E", "F", // a-f
                "G", "THE ", "I", "J", // g
                "K", "L", "M", "N", // k
                "O", "P", "Q", "R", // o
                "S", "T", "U", "V", // s
                "W", "X", "Y", "Z", // w
                "D", "I ", "THAT ", "YOU ", // th
                ".",
                ",",
                "!",
                "?",
                "-",
                "'",
                "\\",
                "/",
                "DON'T ",
                "WH",
                "TH",
                "_Up",
                "_Down",
                "_PgUp",
                "_PgDn",
                "_BS",
                "_WLeft",
                "_Left",
                "_Home",
                " ",
                "_WRight",
                "_Right",
                "_End",
                "_Enter",
                "_Tab",
                "_Esc",
                "_Del",
                "_Ins",
                "_Shift",
                "_SYMB",
                "_123abc",
                "_Ctrl",
                "_Alt"];

var Language = {
                "English":0, "Esperanto":1, "Estonian":2, "Danish_Norwegian":3, "Finnish":4, "Swedish":5,
                "German":6, "French":7, "Icelandic":8, "Italian":9, "Spanish":10, "Portuguese":11, "Russian":12,
    "Greek":13, "Korean":14, "Ukrainan":15, "Malay": 16, "Devanagari": 17 }

var languageIndication = ["English", "Esperanto", "Estonian", "Dan/Nor", "Finnish", "Swedish",
    "German", "French", "Icelandic", "Italian", "Spanish", "Portuguese", "Russian",
                          "Greek", "Korean", "Ukrainan", "Malay", "Devanagari" ]

                var initJamo = new Array(); // int[256];
                var medJamo = new Array(); // int[256];
                var finJamo = new Array(); // int[256];


function setTheme(theme) {

    switch (theme){ // Cloudy, Neon, Warm, Healthy

    // (Button sizes: Main 120x96, Middle 60x96, Bar 290x86, Top 76x86)

    case 1:
        themeMainButton = "images/mainButtonCelo.png";
        themeMiddleButton = "images/middleButtonCelo.png";
        themeBarButton = "images/barButtonCelo.png"
        themeLeftBarButton = "images/barButtonCelo.png"
        themeTopButton = "images/middleButtonCelo.png";
        break;
    case 2:
        themeMainButton = "images/mainButtonBlue.png";
        themeMiddleButton = "images/middleButtonBlue.png";
        themeBarButton = "images/barButtonBlue.png"
        themeLeftBarButton = "images/barButtonBlue.png"
        themeTopButton = "images/middleButtonBlue.png";
        break;
    case 3:
        themeMainButton = "images/mainButtonPassion.png";
        themeMiddleButton = "images/middleButtonPassion.png";
        themeBarButton = "images/barButtonPassion.png"
        themeLeftBarButton = "images/barButtonPassion.png"
        themeTopButton = "images/middleButtonPassion.png";
        break;
    case 4:
        themeMainButton = "images/mainButtonHealthy.png";
        themeMiddleButton = "images/middleButtonHealthy.png";
        themeBarButton = "images/barButtonHealthy.png"
        themeLeftBarButton = "images/barButtonHealthy.png"
        themeTopButton = "images/middleButtonHealthy.png";
        break;
    case 5:
        themeMainButton = "images/mainButtonGrey.png";
        themeMiddleButton = "images/middleButtonGrey.png";
        themeBarButton = "images/barButtonGrey.png"
        themeLeftBarButton = "images/barButtonGrey.png"
        themeTopButton = "images/middleButtonGrey.png";
        break;

    case 6:
        themeMainButton = "images/mainButtonSchool.png";
        themeMiddleButton = "images/middleButtonSchool.png";
        themeBarButton = "images/barButtonSchool.png"
        themeLeftBarButton = "images/leftBarButtonSchool.png"
        themeTopButton = "images/topButtonSchool.png";
        break;

    default:
        // othes values of buttonTheme
        themeMainButton = "images/mainButtonCelo.png";
        themeMiddleButton = "images/middleButtonCelo.png";
        themeBarButton = "images/barButtonCelo.png"
        themeLeftBarButton = "images/barButtonCelo.png"
        themeTopButton = "images/middleButtonCelo.png";

        break;
    }
}


function setLanguage(lan, optimized) {

                var lang = lan ; // valueOf(Langueage.Finnish) ; // valueOf(Language.gLanguage);
                var estonianVersion = false;
                var ukrainianVersion = false;
                devanagariOn = false; // Global variable default

                // var myCars=new Array();

//                // Javascript requirement (not undefined):
//                var y=0;
//                for (y=0; y<=265; y++)
//                {
//                    initJamo[y] = 0; medJamo[y] = 0; finJamo[y] = 0;
//                }


                //boolean useVibrator = GKOSKeyboardView.prefs.getBoolean("PREFERENCES_VIBRATOR_ON", true);

                var opt = optimized ? 1: 0; // optLayout == 1, opt == 1; opt3 = 0 // Recommended optimisation
                if (opt3 == 1){opt = 0;}    // optLayout == 1, opt == 0, opt3 = 1 // Experimental optimisation


    // debug:
    console.log("Language: " + lan + ", lang: " + lang + ", opt: " + opt )


//		int opt = 0;
//		if (optimizedLayout){
//				opt = 1; // Optimized Layout in use
//		}
//
                // Modify set according to language setting in preferences
                // 0, 64, 129, 192, 256 = abc, Abc, ABC, 123, SYMB, Hangul (한글)

                // TODO: remove redundancy

                // Leave this part as is if Korean was selected
//                if (lang != Language.valueOf("Korean")){
                    if (lang != 14){ // TODO

                // Basic latin a-z / A-Z every time

      for (var j = 0; j < 321; j = j + 320) { // Lower case 0 - 65 and aux 320

                GKOSChars[1 + j] = "a";
                GKOSChars[2 + j + 11 * opt + 11 * opt3] = "b";
                GKOSChars[3 + j + 18 * opt3] = "c";
                GKOSChars[4 + j + 23 * opt + 23 * opt3] = "d";
                GKOSChars[5 + j] = "e";
                GKOSChars[6 + j + 12 * opt + 11 * opt3] = "f";
                GKOSChars[7 + j + 2 * opt + 5 * opt3] = "g";
                GKOSChars[8 + j + 4 * opt + 1 * opt3] = "h";
                GKOSChars[9 + j - 5 * opt - 7 * opt3] = "i";
                GKOSChars[10 + j] = "j";
                GKOSChars[11 + j + 3 * opt + 3 * opt3] = "k";
                GKOSChars[12 + j + 11 * opt + 11 * opt3] = "l";
                GKOSChars[13 + j - 11 * opt - 7 * opt3] = "m";
                GKOSChars[14 + j - 3 * opt - 3 * opt3] = "n";
                GKOSChars[15 + j] = "o";
                GKOSChars[16 + j] = "p";
                GKOSChars[17 + j + 1 * opt3] = "q";
                GKOSChars[18 + j - 12 * opt - 15 * opt3] = "r";
                GKOSChars[19 + j] = "s";
                GKOSChars[20 + j - 13 * opt - 13 * opt3] = "t";
                GKOSChars[21 + j - 17 * opt3] = "u";
                GKOSChars[22 + j] = "v";
                GKOSChars[23 + j - 3 * opt - 3 * opt3] = "w";
                GKOSChars[24 + j] = "x";
                GKOSChars[25 + j] = "y";
                GKOSChars[26 + j] = "z";



                for (var i = 0; i < 65; i = i + 64) { // Upper case 65 - 128, CAPS 129 -
                                                                                                // 191
                        GKOSChars[65 + j + i] = "A";
                        GKOSChars[66 + j + i + 11 * opt + 11 * opt3] = "B";
                        GKOSChars[67 + j + i + 18 * opt3] = "C";
                        GKOSChars[68 + j + i + 23 * opt + 23 * opt3] = "D";
                        GKOSChars[69 + j + i] = "E";
                        GKOSChars[70 + j + i + 12 * opt + 11 * opt3] = "F";
                        GKOSChars[71 + j + i + 2 * opt + 5 * opt3] = "G";
                        GKOSChars[72 + j + i + 4 * opt + 1 * opt3] = "H";
                        GKOSChars[73 + j + i - 5 * opt - 7 * opt3] = "I";
                        GKOSChars[74 + j + i] = "J";
                        GKOSChars[75 + j + i + 3 * opt + 3 * opt3] = "K";
                        GKOSChars[76 + j + i + 11 * opt + 11 * opt3] = "L";
                        GKOSChars[77 + j + i - 11 * opt - 7 * opt3] = "M";
                        GKOSChars[78 + j + i - 3 * opt - 3 * opt3] = "N";
                        GKOSChars[79 + j + i] = "O";
                        GKOSChars[80 + j + i] = "P";
                        GKOSChars[81 + j + i + 1 * opt3] = "Q";
                        GKOSChars[82 + j + i - 12 * opt - 15 * opt3] = "R";
                        GKOSChars[83 + j + i] = "S";
                        GKOSChars[84 + j + i - 13 * opt - 13 * opt3] = "T";
                        GKOSChars[85 + j + i - 17 * opt3] = "U";
                        GKOSChars[86 + j + i] = "V";
                        GKOSChars[87 + j + i - 3 * opt - 3 * opt3] = "W";
                        GKOSChars[88 + j + i] = "X";
                        GKOSChars[89 + j + i] = "Y";
                        GKOSChars[90 + j + i] = "Z";

                        // Optimized layout: Also swap parenthesis on TH and W keys: )( => ()
                        GKOSChars[23 + 192 + i + opt * 4 + 4 * opt3] = "(";
                        GKOSChars[27 + 192 + i - opt * 4 - 4 * opt3] = ")";
                        // Optimized layout: Also swap # and @ keys:
                        GKOSChars[11 + 192 + i + opt + opt3] = "#";
                        GKOSChars[12 + 192 + i - opt - opt3] = "@";


                } // i

           } // j

      if (opt == 1){ // for aux sets only

                  GKOSChars[8 + 320] = "the ";
                  GKOSChars[8 + 320 + 64] = "The ";
                  GKOSChars[8 + 320 + 128] = "THE "; // with
      }

                } // End of not Korean

                // Most languages have these:

                GKOSChars[33 + 256] = "\u0021"; // = !
                GKOSChars[34 + 256] = "\u003f"; // = ?
                GKOSChars[41 + 192] = "\u007e"; // NUM: Tilde (~)(small 02dc, bigger 007e)
                GKOSChars[57 + 256] = "\u00ba"; // SYMB/Ins: Degree sign (also 02da is but smaller)

                GKOSChars[40 + 256] = "§"; // SYMB/keyS
                GKOSChars[39 + 192] = "\u00b5"; // NUM/keyK: µ, mu, myy (middle key righ down)
                GKOSChars[39 + 256] = "\u00a8"; // SYMB/keyK: double dots
                GKOSChars[57 + 256] = "\u00ba"; // SYMB/Ins: Degree sign (also 02da is but smaller)

                GKOSChars[35 + 256] = "»"; // SYMB/-
                GKOSChars[36 + 256] = "«"; // SYMB/'

                // Punctuation must be initialized also due to Devanagari
                GKOSChars[31] = "."; // Abc
                GKOSChars[95] = ":"; // Abc
                GKOSChars[95 + 64] = "."; // ABC

                GKOSChars[32] = ","; // Abc
                GKOSChars[96] = ";"; // Abc
                GKOSChars[96 + 64] = ","; // ABC

                GKOSChars[33] = "!"; // Abc
                GKOSChars[97] = "|"; // Abc
                GKOSChars[97 + 64] = "!"; // ABC

                GKOSChars[34] = "?"; // Abc
                GKOSChars[98] = "\u007e"; // Abc tilde
                GKOSChars[98 + 64] = "?"; // ABC

                GKOSChars[35] = "-"; // Abc
                GKOSChars[99] = "_"; // Abc
                GKOSChars[99 + 64] = "-"; // ABC

                GKOSChars[36] = "'"; // Abc
                GKOSChars[100] = "\""; // Abc
                GKOSChars[100 + 64] = "'"; // ABC

                /*
                if (opt ==1){ // testing this option: w is half as common as d
                GKOSChars[20] = "w"; GKOSChars[20 + 64] = "W"; GKOSChars[20 + 128] = "W"; // w <=> d (orig t)
                GKOSChars[23] = "d"; GKOSChars[23 + 64] = "d"; GKOSChars[23 + 128] = "d";
                }
                */

                switch (lang) {
                case Language.English: // English
                        // 0,   64,  129, 192, 256
                        // abc, Abc, ABC, 123, SYMB
                        GKOSChars[27] = "th";
                        GKOSChars[27 + 64] = "Th";
                        GKOSChars[27 + 128] = "TH"; // th

                        GKOSChars[28] = "that ";
                        GKOSChars[28 + 64] = "That ";
                        GKOSChars[28 + 128] = "THAT "; // that

                        GKOSChars[29] = "the ";
                        GKOSChars[29 + 64] = "The ";
                        GKOSChars[29 + 128] = "THE ";// the

                        GKOSChars[30] = "of ";
                        GKOSChars[30 + 64] = "Of ";
                        GKOSChars[30 + 128] = "OF "; // of
                        // ---
                        GKOSChars[39] = "and ";
                        GKOSChars[39 + 64] = "And ";
                        GKOSChars[39 + 128] = "AND "; // and
                        GKOSChars[39 + 192] = "\u00b5"; // µ, mu

                        GKOSChars[40] = "with ";
                        GKOSChars[40 + 64] = "With ";
                        GKOSChars[40 + 128] = "WITH "; // with
                        GKOSChars[40 + 192] = "\u00a7"; // section sign

                        GKOSChars[41] = "to ";
                        GKOSChars[41 + 64] = "To ";
                        GKOSChars[41 + 128] = "TO ";

                        if (opt == 1){

                        GKOSChars[28] = "I ";
                        GKOSChars[28 + 64] = "I'm ";
                        GKOSChars[28 + 128] = "I "; // that

                        GKOSChars[41] = "th";
                        GKOSChars[41 + 64] = "Th";
                        GKOSChars[41 + 128] = "TH"; // to

                        GKOSChars[29] = "that ";
                        GKOSChars[29 + 64] = "That ";
                        GKOSChars[29 + 128] = "THAT "; // the

                        GKOSChars[39] = "don't ";
                        GKOSChars[39 + 64] = "Don't ";
                        GKOSChars[39 + 128] = "DON'T "; // and

                        GKOSChars[30] = "you ";
                        GKOSChars[30 + 64] = "You ";
                        GKOSChars[30 + 128] = "YOU "; // of

                        GKOSChars[40] = "wh";
                        GKOSChars[40 + 64] = "Wh";
                        GKOSChars[40 + 128] = "WH"; // with

                        GKOSChars[8] = "the ";
                        GKOSChars[8 + 64] = "The ";
                        GKOSChars[8 + 128] = "THE "; // with

                        GKOSChars[27] = "d";
                        GKOSChars[27 + 64] = "D";
                        GKOSChars[27 + 128] = "D"; // th

                        }

                        if (opt3 == 1){ // 2-hand optimized (experimental)

                            GKOSChars[28] = "I ";
                            GKOSChars[28 + 64] = "I'm ";
                            GKOSChars[28 + 128] = "I "; // that

                            GKOSChars[41] = "th";
                            GKOSChars[41 + 64] = "Th";
                            GKOSChars[41 + 128] = "TH"; // to

                            GKOSChars[29] = "that ";
                            GKOSChars[29 + 64] = "That ";
                            GKOSChars[29 + 128] = "THAT "; // the

                            GKOSChars[39] = "don't ";
                            GKOSChars[39 + 64] = "Don't ";
                            GKOSChars[39 + 128] = "DON'T "; // and

                            GKOSChars[30] = "you ";
                            GKOSChars[30 + 64] = "You ";
                            GKOSChars[30 + 128] = "YOU "; // of

                            GKOSChars[40] = "wh";
                            GKOSChars[40 + 64] = "Wh";
                            GKOSChars[40 + 128] = "WH"; // with

                            GKOSChars[8] = "the ";
                            GKOSChars[8 + 64] = "The ";
                            GKOSChars[8 + 128] = "THE "; // with

                            GKOSChars[27] = "d";
                            GKOSChars[27 + 64] = "D";
                            GKOSChars[27 + 128] = "D"; // th

                            }



                        //GKOSChars[41 + 192] = "\u02da"; // NUM: Degree sign, was 02c7, Combining caron U+030C ( ̌ )
                        GKOSChars[41 + 256] = "\u02c7"; // SYMB: inv v on top

                        //GKOSChars[57 + 256] = "\u0080"; // SYMB/Ins: Degree sign
                        break;

                        // 0,  64,  128, 192, 256
                        //abc, Abc, ABC, 123, SYMB

                case Language.Esperanto: // Esperanto


//			Ĉ 	C-circumflex 	U+0108 	&#264;x
//			ĉ 	c-circumflex 	U+0109 	&#265;
//			Ĝ 	G-circumflex 	U+011C 	&#284;x
//			ĝ 	g-circumflex 	U+011D 	&#285;
//			Ĥ 	H-circumflex 	U+0124 	&#292;x
//			ĥ 	h-circumflex 	U+0125 	&#293;
//			Ĵ 	J-circumflex 	U+0134 	&#308;x
//			ĵ 	j-circumflex 	U+0135 	&#309;
//			Ŝ 	S-circumflex 	U+015C 	&#348;x
//			ŝ 	s-circumflex 	U+015D 	&#349;
//			Ŭ 	U-breve		 	U+016C 	&#364;x
//			ŭ 	u-breve 		U+016D 	&#365;
                        GKOSChars[27] = "\u0303"; // ~
                        GKOSChars[27 + 64] = "\u0303";
                        GKOSChars[27 + 128] = "\u0303"; // th

                        GKOSChars[28] = "\u0135"; // Ĵ
                        GKOSChars[28 + 64] = "\u0134";
                        GKOSChars[28 + 128] = "\u0134"; // that

                        GKOSChars[29] = "\u016d";
                        GKOSChars[29 + 64] = "\u016c";
                        GKOSChars[29 + 128] = "\u016c";// the

                        GKOSChars[30] = "\u0109"; //Ĉ
                        GKOSChars[30 + 64] = "\u0108";
                        GKOSChars[30 + 128] = "\u0108"; // of
                        // ---
                        GKOSChars[33 + 256] = "\u00a1"; // inverted !
                        GKOSChars[34 + 256] = "\u00bf"; // inverted ?
                        // ---
                        GKOSChars[39] = "\u0125"; // Ĥ
                        GKOSChars[39 + 64] = "\u0124";
                        GKOSChars[39 + 128] = "\u0124"; // and
                        GKOSChars[39 + 192] = "\u00b5"; // µ, mu (123)
                        GKOSChars[39 + 256] = "\u0300"; // grave (SYMB)

                        GKOSChars[40] = "\u015d"; // Ŝ
                        GKOSChars[40 + 64] = "\u015c";
                        GKOSChars[40 + 128] = "\u015c"; // with
                        GKOSChars[40 + 192] = "\u00a7"; // section sign
                        GKOSChars[40 + 256] = "\u0301"; // acute (SYMB)

                        GKOSChars[41] = "\u011d"; // Ĝ
                        GKOSChars[41 + 64] = "\u011c";
                        GKOSChars[41 + 128] = "\u011c";
                        //GKOSChars[41 + 192] = "\u02c7"; // to (123)
                        GKOSChars[41 + 256] = "\u02c7"; // v on top (SYMB)

                        //GKOSChars[57 + 256] = "\u00ba"; // SYMB/Ins: o high up

                        if (opt == 1){
                                setBasicOptimisation();

                                GKOSChars[12] = "d"; GKOSChars[12 + 64] = "D"; GKOSChars[12 + 128] = "D"; // As in Finnish l => Key D
                                GKOSChars[21] = "\u015d"; GKOSChars[21 + 64] = "\u015c"; GKOSChars[21 + 128] = "\u015c"; // with // Ŝ => U
                                //GKOSChars[40] = "\u0303"; GKOSChars[40 + 64] = "\u0303"; GKOSChars[40 + 128] = "\u0303"; // ~ => Ŝ (with)
                                // acute/double-dots/tilde/grave:
                                GKOSChars[40] = "\u0301"; GKOSChars[40 + 64] = "\u0300"; GKOSChars[40 + 128] = "\u0301"; GKOSChars[40 + 192] = "\u0303"; GKOSChars[40 + 256] = "\u00a8";
                                GKOSChars[27] = "u"; GKOSChars[27 + 64] = "U"; GKOSChars[27 + 128] = "U"; // u => TH

                                }


                        break;


                case Language.Danish_Norwegian:// Danish Norwegian

                        if (opt == 1){
                                setBasicOptimisation();
                                }


                        //GKOSChars[27] = "\u00fc";
                        //GKOSChars[27 + 64] = "\u00dc";
                        //GKOSChars[27 + 128] = "\u00dc"; // th

                        GKOSChars[28] = "\u00e5";
                        GKOSChars[28 + 64] = "\u00c5";
                        GKOSChars[28 + 128] = "\u00c5"; // that

                        GKOSChars[29] = "\u00e6";
                        GKOSChars[29 + 64] = "\u00c6";
                        GKOSChars[29 + 128] = "\u00c6";// the

                        GKOSChars[30] = "\u00f8";
                        GKOSChars[30 + 64] = "\u00d8";
                        GKOSChars[30 + 128] = "\u00d8"; // of
                        // ---
                        GKOSChars[39] = "\u00a8"; // 0308 does not work
                        GKOSChars[39 + 64] = "\u00a8";
                        GKOSChars[39 + 128] = "\u00a8"; // and
                        GKOSChars[39 + 192] = "\u00b5"; // µ, mu

                        GKOSChars[40] = "\u00df";
                        GKOSChars[40 + 64] = "\u00df";
                        GKOSChars[40 + 128] = "\u00df"; // with
                        GKOSChars[40 + 192] = "\u00a7"; // section sign

                        GKOSChars[41] = "\u02c6"; // to
                        GKOSChars[41 + 64] = "\u02c6";
                        GKOSChars[41 + 128] = "\u02c6";
                        //GKOSChars[41 + 192] = "\u02c7"; // combining caron U+030C ( ̌ )
                        GKOSChars[41 + 256] = "\u02c7"; // inv v on top

                        //GKOSChars[57 + 256] = "\u00ba"; // SYMB/Ins: Degree sign
                        break;
                case Language.Estonian: // Estonian is almost Finnish, just replace å with õ

                        estonianVersion = true;

                case Language.Finnish:// German/Swedish/Finnish

                        GKOSChars[27] = "ü"; GKOSChars[27 + 64] = "Ü"; GKOSChars[27 + 128] = "Ü"; // Alphabetic layout
                        GKOSChars[29] = "ä"; GKOSChars[29 + 64] = "Ä"; GKOSChars[29 + 128] = "Ä"; // Alphabetic layout

                        setUmlautLayout();

                        if (opt == 1){
                                setBasicOptimisation();

                        // Finnish special:
                        GKOSChars[27] = "ä"; GKOSChars[27 + 64] = "Ä"; GKOSChars[27 + 128] = "Ä"; // Finnish ä => TH
                        GKOSChars[12] = "d"; GKOSChars[12 + 64] = "D"; GKOSChars[12 + 128] = "D"; // Finnish l => D
                            GKOSChars[28] = "å"; GKOSChars[28 + 64] = "Å"; GKOSChars[28 + 128] = "Ä"; // ü
                            GKOSChars[29] = "ö"; GKOSChars[29 + 64] = "Ö"; GKOSChars[29 + 128] = "Ö"; // ö
                            GKOSChars[30] = "ü"; GKOSChars[30 + 64] = "Ü"; GKOSChars[30 + 128] = "Ü"; // å
                        }

                        if (opt3 == 1){ // two-hand optimized
                            // easier to reach ü and ö (common)
                            GKOSChars[8] = "d"; GKOSChars[8 + 64] = "D"; GKOSChars[8 + 128] = "D"; // å
                            GKOSChars[27] = "ä"; GKOSChars[27 + 64] = "Ä"; GKOSChars[27 + 128] = "Ä"; // d => TH
                            GKOSChars[28] = "å"; GKOSChars[28 + 64] = "Å"; GKOSChars[28 + 128] = "Ä"; // ü
                            GKOSChars[29] = "ö"; GKOSChars[29 + 64] = "Ö"; GKOSChars[29 + 128] = "Ö"; // ö
                            GKOSChars[30] = "ü"; GKOSChars[30 + 64] = "Ü"; GKOSChars[30 + 128] = "Ü"; // å
                        }




                        if (estonianVersion){ // Estonian exceptions to the Umlaut set
                                GKOSChars[28] = "\u00f5"; // õ
                                GKOSChars[28 + 64] = "\u00D5";
                                GKOSChars[28 + 128] = "\u00D5"; // that

                                GKOSChars[40] = "\u0161"; // Double s => s with caron
                                GKOSChars[40 + 64] = "\u0160"; // double s => capital s with caron
                                GKOSChars[40 + 128] = "\u0160"; // double s => capital s with caron

                                GKOSChars[39] = "\u017e"; // combining diaresis => z with caron //and
                                GKOSChars[39 + 64] = "\u017d"; //
                                GKOSChars[39 + 128] = "\u017d"; // ( ̈  = z with v above)
                        }

                        break;

               // ----------------------------------------------------

                case Language.Devanagari: // Devanagari/Sanskrit/Hindi

                    devanagariOn = true;

                        // Independent vowels:
                        GKOSChars[1] = "अ"; // abc -a
                        GKOSChars[2] = "इ"; // -i
                        GKOSChars[3] = "ऋ"; // -r dot under
                        GKOSChars[4] = "उ"; // -u
                        GKOSChars[5] = "ए"; // -e
                        GKOSChars[6] = "ओ"; // -o

                        // Consonants:
                        GKOSChars[7] = "त"; // G -t
                        GKOSChars[8] = "थ"; // -th
                        GKOSChars[9] = "द"; // -d
                        GKOSChars[10] = "ध"; // -dh

                    GKOSChars[11] = "न"; // K -p => -n
                        GKOSChars[12] = "ञ"; // -n line above
                        GKOSChars[13] = "ण"; // -n dot below
                        GKOSChars[14] = "ङ"; // -n dot above

                    GKOSChars[15] = "क"; // O -k
                        GKOSChars[16] = "ख"; // -kh
                        GKOSChars[17] = "ग"; // -g
                        GKOSChars[18] = "घ"; // -gh

                    GKOSChars[19] = "स"; // S -s (*frequent)
                        GKOSChars[20] = "ष"; // -s dot below
                        GKOSChars[21] = "श"; // -s acute (*less frequent)
                        GKOSChars[22] = "ह"; // -h

                        GKOSChars[23] = "प"; // w -n => -p
                        GKOSChars[24] = "फ"; // -ph
                        GKOSChars[25] = "ब"; // -b
                        GKOSChars[40] = "भ"; // § lower middle key // -bh
                        GKOSChars[26] = "म"; // -m

                        GKOSChars[27] = "र"; //  TH -r (*frequent)
                        GKOSChars[28] = "य"; // -y [j] (*less frequent)
                        GKOSChars[41] = "ज"; // upper middle key // -j [dz] (not in this group but common)
                        GKOSChars[29] = "ल"; // -l
                        GKOSChars[39] = "व"; // lower middle key // -v
                        GKOSChars[30] = "ळ"; // -l dot below
                        // End of consonants

                 // 31-36 = "." = -ii,  "," = -ee(ai),  "!" = -rr,  "?" = -oo(au), "-" = -aa, "'" = -uu
                        // More vowels:
                        GKOSChars[31] = "ई"; // -ii
                        GKOSChars[32] = "ऐ"; // -ee(ai)
                        GKOSChars[33] = "ॠ"; // -rr
                        GKOSChars[34] = "औ"; // -oo(au)
                        GKOSChars[35] = "आ"; // -aa
                        GKOSChars[36] = "ऊ"; // -uu



                        // UPPER CASE and CAPS
                        // Upper case 65 - 128: Special vowels etc. and rare consonants
                        // CAPS 129 - 191: Dependent vowels and common consonants
                            // Vowels:
                            GKOSChars[65] = "ँ"; // -a // Special vowels etc.
                            GKOSChars[65 + 64] = "ा"; // -aa halant // Dependent vowels

                            GKOSChars[66] = "ं"; //
                            GKOSChars[66 + 64] = "ि"; // -i

                            GKOSChars[67] = ""; // -r (dot under)
                            GKOSChars[67 + 64] = "ृ"; // -r (dot under)

                            GKOSChars[68] = "॓"; // -grave
                            GKOSChars[68 + 64] = "ु"; // -u

                            GKOSChars[69] = "ॆ"; // -short e
                            GKOSChars[69 + 64] = "े"; // -e

                            GKOSChars[70] = "ॊ"; // -short o
                            GKOSChars[70 + 64] = "ो"; // -o

                            // Consonants:
                            GKOSChars[71] = "ट";// G -t dot under
                            GKOSChars[71 + 64] = "त";// G -t
                            GKOSChars[72] = "ठ"; // -th dot under
                            GKOSChars[72 + 64] = "थ"; // -th
                            GKOSChars[73] = "ड"; // -d dot under
                            GKOSChars[73 + 64] = "द"; // -d
                            GKOSChars[74] = "ढ"; // -dh dot under
                            GKOSChars[74 + 64] = "ध"; // -dh

                            GKOSChars[75] = "";// K 15 -z [z]
                            GKOSChars[75 + 64] = "न";// O 15 -p => -n
                            GKOSChars[76] = ""; // -ph => -n line above
                            GKOSChars[76 + 64] = "ञ"; // -ph => -n line above
                            GKOSChars[77] = ""; // -b => -n dot below
                            GKOSChars[77 + 64] = "ण"; // -b => -n dot below
                            GKOSChars[78] = ""; // 18 -bh => -n dot above
                            GKOSChars[78 + 64] = "ङ"; // 18 -bh => -n dot above

                            GKOSChars[79] = "क़"; // O -k dot under, q
                            GKOSChars[79 + 64] = "क"; // K -k
                            GKOSChars[80] = "ख़"; // -kh dot under
                            GKOSChars[80 + 64] = "ख"; // -kh
                            GKOSChars[81] = "ग़"; // S -g dot under
                            GKOSChars[81 + 64] = "ग"; // -g
                            GKOSChars[82] = ""; // -gh
                            GKOSChars[82 + 64] = "घ"; // -gh

                            GKOSChars[83] = "ज";// S // -j [dz]
                            GKOSChars[83 + 64] = "स";// S // -s
                            GKOSChars[84] = "झ"; // -jh [dzh]
                            GKOSChars[84 + 64] = "ष"; // -s dot below
                            GKOSChars[85] = "च"; // -c
                            GKOSChars[85 + 64] = "श"; // -s acute
                            GKOSChars[86] = "छ"; // -ch
                            GKOSChars[86 + 64] = "ह"; // -h

                            GKOSChars[87] = ""; // W // -n => -p
                            GKOSChars[87 + 64] = "प"; // W // -n => -p
                            GKOSChars[88] = ""; // -ph
                            GKOSChars[88 + 64] = "फ"; // -ph
                            // -------- Ins -------- // upper middle key //
                            GKOSChars[89] = ""; // -b
                            GKOSChars[89 + 64] = "ब"; // -b
                            GKOSChars[104] = "";// lower middle key // -bh
                            GKOSChars[104 + 64] = "भ";// lower middle key // -bh
                            GKOSChars[90] = ""; // -m
                            GKOSChars[90 + 64] = "म"; // -m

                            GKOSChars[91] = "ड़";// Ü // -r dot below
                            GKOSChars[91 + 64] = "र";// Ü // -r
                            GKOSChars[92] = "य़"; // -y dot below, [zz]
                            GKOSChars[92 + 64] = "य"; // -y [j]
                            GKOSChars[105] = "ज़"; // upper middle key // -j [dz] dot below
                            GKOSChars[105 + 64] = "ज"; // upper middle key // -j [dz] (not in this group but common)
                            GKOSChars[93] = "ज़"; // -rh dot below
                            GKOSChars[93 + 64] = "ल"; // -l
                            GKOSChars[103] = "फ़";// -f
                            GKOSChars[103 + 64] = "व";// lower middle key // -v
                            GKOSChars[94] = ""; // 30 -l dot below
                            GKOSChars[94 + 64] = "ळ"; // 30 -l dot below
                            // End of consonants

                            // More vowels:
                            // 95-100 = "." = -ii,  "," = -ee(ai),  "!" = -rr,  "?" = -oo(au), "-" = -aa, "'" = -uu
                                   GKOSChars[95] = "़"; // - // KeyB
                            GKOSChars[95 + 64] = "ी"; // -ii
                                   GKOSChars[96] = "ॅ"; // -candra e // KeyE
                            GKOSChars[96 + 64] = "ै"; // -ee(ai)
                                   GKOSChars[97] = "!"; // -rr KeyC
                            GKOSChars[97 + 64] = "ॄ"; // -rr
                                   GKOSChars[98] = "ॉ"; // -candra o // KeyF
                            GKOSChars[98 + 64] = "ौ"; // -oo(au)
                                   GKOSChars[99] = "ः"; // - // KeyA
                            GKOSChars[99 + 64] = "\u094d"; // (-a) halant (suppres a)
                                   GKOSChars[100] = "॔"; // -acute // KeyD
                            GKOSChars[100 + 64] = "ू"; // -uu

                    // ॅ ॆ े ै ॉ ॊ ो ौ = ? ? e ai ? ? o au
                    // ँ ं ः ़ ॑ ॒ ॓ ॔
                    // ०१२३४५६७८९
                    // ₹ । ॥ ॰


                        break;


               // -----------------------------------------------------

                case Language.Swedish:// German/Swedish/Finnish

                        GKOSChars[27] = "ü"; GKOSChars[27 + 64] = "Ü"; GKOSChars[27 + 128] = "Ü"; // Alphabetic layout
                        GKOSChars[29] = "ä"; GKOSChars[29 + 64] = "Ä"; GKOSChars[29 + 128] = "Ä"; // Alphabetic layout

                        setUmlautLayout();

                        if (opt == 1){
                                setBasicOptimisation();

                        // Swedish special:
                        GKOSChars[27] = "d"; GKOSChars[27 + 64] = "D"; GKOSChars[27 + 128] = "D"; // ä => TH
                        GKOSChars[12] = "ä"; GKOSChars[12 + 64] = "Ä"; GKOSChars[12 + 128] = "Ä"; // l => D
                            GKOSChars[28] = "å"; GKOSChars[28 + 64] = "Å"; GKOSChars[28 + 128] = "Ä"; // ü
                            GKOSChars[29] = "ö"; GKOSChars[29 + 64] = "Ö"; GKOSChars[29 + 128] = "Ö"; // ö
                            GKOSChars[30] = "ü"; GKOSChars[30 + 64] = "Ü"; GKOSChars[30 + 128] = "Ü"; // å
                        }

                        if (opt3 == 1){
                            // easier to reach ü and ö (common)
                            GKOSChars[8] = "ä"; GKOSChars[8 + 64] = "Ä"; GKOSChars[8 + 128] = "Ä"; // å
                            GKOSChars[27] = "d"; GKOSChars[27 + 64] = "D"; GKOSChars[27 + 128] = "D"; // d => TH
                            GKOSChars[28] = "å"; GKOSChars[28 + 64] = "Å"; GKOSChars[28 + 128] = "Ä"; // ü
                            GKOSChars[29] = "ö"; GKOSChars[29 + 64] = "Ö"; GKOSChars[29 + 128] = "Ö"; // ö
                            GKOSChars[30] = "ü"; GKOSChars[30 + 64] = "Ü"; GKOSChars[30 + 128] = "Ü"; // å
                        }



                        break;

                case Language.German:// German/Swedish/Finnish

                        GKOSChars[27] = "ü"; GKOSChars[27 + 64] = "Ü"; GKOSChars[27 + 128] = "Ü"; // Alphabetic layout
                        GKOSChars[29] = "ä"; GKOSChars[29 + 64] = "Ä"; GKOSChars[29 + 128] = "Ä"; // Alphabetic layout

                        setUmlautLayout();

                        if (opt == 1){
                                setBasicOptimisation();

                        // German special:
                        GKOSChars[27] = "d"; GKOSChars[27 + 64] = "D"; GKOSChars[27 + 128] = "D"; // ä => TH
                        GKOSChars[12] = "ä"; GKOSChars[12 + 64] = "Ä"; GKOSChars[12 + 128] = "Ä"; // l => D
                            GKOSChars[28] = "ü"; GKOSChars[28 + 64] = "Ü"; GKOSChars[28 + 128] = "Ü"; // å
                            GKOSChars[29] = "ö"; GKOSChars[29 + 64] = "Ö"; GKOSChars[29 + 128] = "Ö"; // ö
                            GKOSChars[30] = "å"; GKOSChars[30 + 64] = "Å"; GKOSChars[30 + 128] = "Ä"; // ü
                        GKOSChars[3] = "h"; GKOSChars[3 + 64] = "H"; GKOSChars[3 + 128] = "H"; // h => K
                        GKOSChars[8] = "k"; GKOSChars[8 + 64] = "K"; GKOSChars[8 + 128] = "K"; // k => H
                        GKOSChars[21] = "m"; GKOSChars[21 + 64] = "M"; GKOSChars[21 + 128] = "M"; // m => U
                        GKOSChars[2] = "u"; GKOSChars[2 + 64] = "U"; GKOSChars[2 + 128] = "U"; // u => M (b orig)
                        }

                        if (opt3 == 1){
                            // easier to reach ü and ö (common)
                            GKOSChars[8] = "ä"; GKOSChars[8 + 64] = "Ä"; GKOSChars[8 + 128] = "Ä"; // å
                            GKOSChars[27] = "d"; GKOSChars[27 + 64] = "D"; GKOSChars[27 + 128] = "D"; // d => TH
                            GKOSChars[28] = "ü"; GKOSChars[28 + 64] = "Ü"; GKOSChars[28 + 128] = "Ü"; // ü
                            GKOSChars[29] = "ö"; GKOSChars[29 + 64] = "Ö"; GKOSChars[29 + 128] = "Ö"; // ö
                            GKOSChars[30] = "å"; GKOSChars[30 + 64] = "Å"; GKOSChars[30 + 128] = "Å"; // å
                        }


                        break;



                case Language.French: // French

                        if (opt == 1){
                                setBasicOptimisation();

                                GKOSChars[21] = "m"; GKOSChars[21 + 64] = "M"; GKOSChars[21 + 128] = "M"; // m => U
                                GKOSChars[2] = "u"; GKOSChars[2 + 64] = "U"; GKOSChars[2 + 128] = "U"; // u => M (b orig)

                                GKOSChars[14] = "k"; GKOSChars[14 + 64] = "K"; GKOSChars[14 + 128] = "K"; // c <=> k back
                                GKOSChars[3] = "c"; GKOSChars[3 + 64] = "C"; GKOSChars[3 + 128] = "C";


                                }

                        GKOSChars[28] = "\u00e9"; // e acute on Key that
                        GKOSChars[28 + 64] = "\u00c9";
                        GKOSChars[28 + 128] = "\u00c9"; // that

                        GKOSChars[12] = "\u00e0"; // a grave on Key L
                        GKOSChars[12 + 64] = "\u00c0";
                        GKOSChars[12 + 128] = "\u00c0"; // L

                        GKOSChars[29] = "\u00e8"; // e grave
                        GKOSChars[29 + 64] = "\u00c8";
                        GKOSChars[29 + 128] = "\u00c8";// (the =>) l

                        GKOSChars[30] = "\u00f9"; //  ù = u grave
                        GKOSChars[30 + 64] = "\u00d9";
                        GKOSChars[30 + 128] = "\u00d9"; // of
                        // ---
                        GKOSChars[39] = "\u0153"; // (oe)
                        GKOSChars[39 + 64] = "\u0152"; // (OE)
                        GKOSChars[39 + 128] = "\u0152"; // and
                        GKOSChars[39 + 192] = "\u0153"; // (oe)

                        GKOSChars[40] = "\u00e7";
                        GKOSChars[40 + 64] = "\u00c7";
                        GKOSChars[40 + 128] = "\u00c7"; // with
                        GKOSChars[40 + 192] = "\u00a7"; // section sign

                        GKOSChars[41] = "\u02c6"; // comb.circumflex "ˆ" (= 02c6 but NOT 0302 nor 005e)
                        GKOSChars[41 + 64] = "\u00a8"; // double-dots   / 005e = separate math ^ symbol
                        GKOSChars[41 + 128] = "\u02c6";
                        //GKOSChars[41 + 192] = "\u02c7"; // combining caron U+030C ( ̌ )
                        GKOSChars[41 + 256] = "\u02c7"; // inv v on top

                        //GKOSChars[57 + 256] = "\u00ba"; // SYMB/Ins: Degree sign
                        break;
                case Language.Icelandic: // Icelandic

                        GKOSChars[40] = "\u00f0"; // (-d)
                        GKOSChars[40 + 64] = "\u00d0"; // (-D)
                        GKOSChars[40 + 128] = "\u00d0"; // (-D) with
                        GKOSChars[40 + 192] = "\u00a7"; // section sign §

                        GKOSChars[27] = "\u00f0"; // (th) f0/d0
                        GKOSChars[27 + 64] = "\u00d0"; // (TH)
                        GKOSChars[27 + 128] = "\u00d0"; // th

                        GKOSChars[28] = "\u00e5"; // å
                        GKOSChars[28 + 64] = "\u00c5"; // Å
                        GKOSChars[28 + 128] = "\u00c5"; // that

                        if (opt == 1){
                                setBasicOptimisation();

                                GKOSChars[2] = "u"; GKOSChars[2 + 64] = "U"; GKOSChars[2 + 128] = "U"; // u => M (b orig)
                                GKOSChars[21] = "m"; GKOSChars[21 + 64] = "M"; GKOSChars[21 + 128] = "M"; // m => U

                                GKOSChars[12] = "\u00fe"; GKOSChars[12 + 64] = "\u00de"; GKOSChars[12 + 128] = "\u00de"; // (-d) fe/de => L
                                //GKOSChars[12] = "o"; GKOSChars[12 + 64] = "O"; GKOSChars[12 + 128] = "O"; // o => L
                                GKOSChars[40] = "\u0301"; GKOSChars[40 + 64] = "\u00a8"; GKOSChars[40 + 128] = "\u0301"; GKOSChars[40 + 192] = "\u0300"; // ex (-d/-D) = acute/ddots/grave
                                // replace å with dh
                                GKOSChars[28] = "\u00f0"; GKOSChars[28 + 64] = "\u00d0"; GKOSChars[28 + 128] = "\u00d0"; // dh // (ex å)
                                // Key TH is d
                                GKOSChars[27] = "d"; GKOSChars[27 + 64] = "D"; GKOSChars[27 + 128] = "D"; // d // (TH)

                                }

                        GKOSChars[41] = "í"; GKOSChars[41 + 64] = "Í"; GKOSChars[41 + 128] = "Í"; // replace grave by í
                        GKOSChars[39] = "á"; GKOSChars[39 + 64] = "Á"; GKOSChars[39 + 128] = "Á"; // replace ddots by á

                        GKOSChars[29] = "\u00e6"; // (ae)
                        GKOSChars[29 + 64] = "\u00c6"; // (AE)
                        GKOSChars[29 + 128] = "\u00c6";// the

                        GKOSChars[30] = "\u00f6"; // ö
                        GKOSChars[30 + 64] = "\u00d6"; // Ö
                        GKOSChars[30 + 128] = "\u00d6"; // of

                        // ---
                        //GKOSChars[39] = "\u00a8"; // 0308 does not work
                        //GKOSChars[39 + 64] = "\u00a8";
                        //GKOSChars[39 + 128] = "\u00a8"; // and
                        GKOSChars[39 + 192] = "\u00b5"; // µ, mu


                        //GKOSChars[41] = "\u0301"; // acute
                        //GKOSChars[41 + 64] = "\u0301";
                        //GKOSChars[41 + 128] = "\u0301";
                        //GKOSChars[41 + 192] = "ˇ"; // combining caron U+030C ( ̌ )
                        GKOSChars[41 + 256] = "\u02c7"; // inv v on top

                        //GKOSChars[57 + 256] = "\u00ba"; // SYMB/Ins: Degree sign
                        break;

                case Language.Italian: // Italian
                        // 0,   64,  129, 192, 256
                        // abc, Abc, ABC, 123, SYMB

                        // Old Alphabetical layout version first:
                        GKOSChars[27] = "\u00e8"; // è e8
                        GKOSChars[27 + 64] = "\u00c8"; // c8
                        GKOSChars[27 + 128] = "\u00c8"; // th

                        //GKOSChars[28] = "\u00e0"; // á
                        //GKOSChars[28 + 64] = "\u00c0";
                        //GKOSChars[28 + 128] = "\u00c0"; // that

                        //GKOSChars[29] = "\u00f9"; // ù f9
                        //GKOSChars[29 + 64] = "\u00d9"; // d9
                        //GKOSChars[29 + 128] = "\u00d9";// the

                        //GKOSChars[30] = "\u00f2"; // ò
                        //GKOSChars[30 + 64] = "\u00d2";
                        //GKOSChars[30 + 128] = "\u00d2"; // of
                        // ---
                        GKOSChars[33 + 256] = "\u00a1"; // inverted !
                        GKOSChars[34 + 256] = "\u00bf"; // inverted ?
                        // ---
                        //GKOSChars[39] = "\u0301"; //  acute
                        //GKOSChars[39 + 64] = "\u0301";
                        //GKOSChars[39 + 128] = "\u0301"; // and
                        GKOSChars[39 + 192] = "\u00b5"; // µ, mu (123)
                        GKOSChars[39 + 256] = "\u00f1"; // ñ (SYMB)

                        //GKOSChars[40] = "\u00e7"; // cedilla
                        //GKOSChars[40 + 64] = "\u00c7";
                        //GKOSChars[40 + 128] = "\u00c7"; // with
                        GKOSChars[40 + 192] = "\u00a7"; // section sign
                        GKOSChars[40 + 256] = "\u00fc"; // ü (SYMB)

                        //GKOSChars[41] = "\u00ec"; // ì
                        //GKOSChars[41 + 64] = "\u00cc";
                        //GKOSChars[41 + 128] = "\u00cc";
                        //GKOSChars[41 + 192] = "\u02c7"; // to (123)
                        GKOSChars[41 + 256] = "\u02c7"; // v on top (SYMB)

                        //GKOSChars[57 + 256] = "\u00ba"; // SYMB/Ins: o high up

                        GKOSChars[28] = "à"; GKOSChars[28 + 64] = "À"; GKOSChars[28 + 128] = "À"; //
                        GKOSChars[29] = "é"; GKOSChars[29 + 64] = "É"; GKOSChars[29 + 128] = "É"; //

                        // Optimised layout:
                        if (opt == 1){
                                setBasicOptimisation();

                                GKOSChars[3] = "c"; GKOSChars[3 + 64] = "C"; GKOSChars[3 + 128] = "C"; // c => K
                                GKOSChars[14] = "k"; GKOSChars[14 + 64] = "K"; GKOSChars[14 + 128] = "K"; // k => C (n orig)

                                GKOSChars[2] = "u"; GKOSChars[2 + 64] = "U"; GKOSChars[2 + 128] = "U"; // u => M (b orig)
                                GKOSChars[21] = "m"; GKOSChars[21 + 64] = "M"; GKOSChars[21 + 128] = "M"; // m => U

                                // ... new layout:
                                // 28 29 30 (å ä ö): à è ò
                                GKOSChars[12] = "à"; GKOSChars[12 + 64] = "À"; GKOSChars[12 + 128] = "À"; //
                                GKOSChars[28] = "é"; GKOSChars[28 + 64] = "É"; GKOSChars[28 + 128] = "É"; //
                                GKOSChars[29] = "è"; GKOSChars[29 + 64] = "È"; GKOSChars[29 + 128] = "È"; //
                        }
                                GKOSChars[30] = "ò"; GKOSChars[30 + 64] = "Ò"; GKOSChars[30 + 128] = "Ò"; //
                                // middle keys 40 39: ì ù
                                GKOSChars[41] = "ì"; GKOSChars[41 + 64] = "Ì"; GKOSChars[41 + 128] = "Ì"; //
                                GKOSChars[39] = "ù"; GKOSChars[39 + 64] = "Ù"; GKOSChars[39 + 128] = "Ù"; //
                                // left lower middle key 40: é (SYMB => ü)
                                GKOSChars[40] = "ü"; GKOSChars[40 + 64] = "Ü"; GKOSChars[40 + 128] = "Ü"; GKOSChars[40 + 256] = "ü"; //



                        break;

                case Language.Spanish: // Spanish

                // TH/ü = ú
                GKOSChars[27] = "\u00fa"; GKOSChars[27 + 64] = "\u00da"; GKOSChars[27 + 128] = "\u00da"; // á (th)

                        if (opt == 1){
                                setBasicOptimisation();

                                GKOSChars[3] = "c"; GKOSChars[3 + 64] = "C"; GKOSChars[3 + 128] = "C"; // c => K
                                GKOSChars[14] = "k"; GKOSChars[14 + 64] = "K"; GKOSChars[14 + 128] = "K"; // k => C (n orig)

                                GKOSChars[2] = "u"; GKOSChars[2 + 64] = "U"; GKOSChars[2 + 128] = "U"; // u => M (b orig)
                                GKOSChars[21] = "m"; GKOSChars[21 + 64] = "M"; GKOSChars[21 + 128] = "M"; // m => U
                                // orig l = á:
                                GKOSChars[12] = "á"; GKOSChars[12 + 64] = "Á"; GKOSChars[12 + 128] = "Á"; // á (th)

                                }


                        GKOSChars[28] = "\u00e1";
                        GKOSChars[28 + 64] = "\u00c1";
                        GKOSChars[28 + 128] = "\u00c1"; // that

                        GKOSChars[29] = "\u00e9";
                        GKOSChars[29 + 64] = "\u00c9";
                        GKOSChars[29 + 128] = "\u00c9";// the

                        GKOSChars[30] = "\u00f3";
                        GKOSChars[30 + 64] = "\u00d3";
                        GKOSChars[30 + 128] = "\u00d3"; // of
                        // ---
                        GKOSChars[33 + 256] = "\u00a1"; // inverted !
                        GKOSChars[34 + 256] = "\u00bf"; // inverted ?
                        // ---
                        GKOSChars[39] = "\u00f1"; // ñ
                        GKOSChars[39 + 64] = "\u00d1";
                        GKOSChars[39 + 128] = "\u00d1"; // and
                        GKOSChars[39 + 192] = "\u005e"; // inv v

                        GKOSChars[40] = "\u00fc";
                        GKOSChars[40 + 64] = "\u00dc";
                        GKOSChars[40 + 128] = "\00dc"; // with
                        GKOSChars[40 + 192] = "\u0308"; // diaer

                        GKOSChars[41] = "\u00ed"; // to?
                        GKOSChars[41 + 64] = "\u00cd";
                        GKOSChars[41 + 128] = "\u00cd";
                        //GKOSChars[41 + 192] = "\u00cd"; //
                        GKOSChars[41 + 256] = "\u00aa"; // a high up

                        //GKOSChars[57 + 256] = "\u00ba"; // SYMB/Ins: o high up
                        break;

                case Language.Portuguese: // Portuguese
                        // 0,   64,  129, 192, 256
                        // abc, Abc, ABC, 123,  SYMB

                        GKOSChars[27] = "\u02c6"; // "ˆ" circumflex 0302, "^" caret 005e, "ˆ" modifier circumflex 02C6
                        GKOSChars[27 + 64] = "\u02c6";
                        GKOSChars[27 + 128] = "\u02c6"; // th

                        GKOSChars[28] = "\u00e3"; // ã
                        GKOSChars[28 + 64] = "\u00c3";
                        GKOSChars[28 + 128] = "\u00c3"; // that

                        GKOSChars[29] = "\u00e9"; // é
                        GKOSChars[29 + 64] = "\u00c9";
                        GKOSChars[29 + 128] = "\u00c9";// (the =>) l

                        GKOSChars[30] = "\u00f5"; // õ
                        GKOSChars[30 + 64] = "\u00d5";
                        GKOSChars[30 + 128] = "\u00d5"; // of
                        // ---
                        GKOSChars[33 + 256] = "\u00a1"; // inverted !
                        GKOSChars[34 + 256] = "\u00bf"; // inverted ?
                        // ---
                        GKOSChars[39] = "\u0300"; // grave
                        GKOSChars[39 + 64] = "\u0300";
                        GKOSChars[39 + 128] = "\u0300"; // and
                        GKOSChars[39 + 192] = "\u00b5"; // µ, mu (123)
                        GKOSChars[39 + 256] = "\u00f1"; // ñ (SYMB)

                        GKOSChars[40] = "\u00e7"; // cedilla
                        GKOSChars[40 + 64] = "\u00c7";
                        GKOSChars[40 + 128] = "\u00c7"; // with
                        GKOSChars[40 + 192] = "\u00a7"; // section sign
                        GKOSChars[40 + 256] = "\u00fc"; // ü (SYMB)


                        GKOSChars[41] = "\u0301"; // acute
                        GKOSChars[41 + 64] = "\u02c6"; // comb.circumflex "ˆ" (= 02c6 but NOT 0302 nor 005e)
                        GKOSChars[41 + 128] = "\u0301";
                        //GKOSChars[41 + 192] = "\u02c7"; // to (123) combining caron U+030C ( ̌ )
                        GKOSChars[41 + 256] = "\u02c7"; // inv v on top (SYMB)


                        //GKOSChars[57 + 256] = "\u00ba"; // SYMB/Ins: o high up

                        if (opt == 1){
                                setBasicOptimisation();

                                GKOSChars[3] = "c"; GKOSChars[3 + 64] = "C"; GKOSChars[3 + 128] = "C"; // c => K
                                GKOSChars[14] = "k"; GKOSChars[14 + 64] = "K"; GKOSChars[14 + 128] = "K"; // k => C (n orig)
                                GKOSChars[12] = "á"; GKOSChars[12 + 64] = "Á"; GKOSChars[12 + 128] = "Á"; // replace ü by á
                                // Move l to original position:
                                GKOSChars[12] = "l"; GKOSChars[12 + 64] = "L"; GKOSChars[12 + 128] = "L"; // replace ü by á
                                GKOSChars[23] = "d"; GKOSChars[23 + 64] = "D"; GKOSChars[23 + 128] = "D"; // replace ü by á
                                // Native part:
                                GKOSChars[27] = "\u0301"; GKOSChars[28 + 64] = "\u0300"; GKOSChars[28 + 128] = "É"; // acute/grave/acute/...
                                GKOSChars[28] = "ã"; GKOSChars[28 + 64] = "Ã"; GKOSChars[28 + 128] = "Ã"; //
                                GKOSChars[29] = "à"; GKOSChars[29 + 64] = "À"; GKOSChars[29 + 128] = "À"; //
                                GKOSChars[30] = "õ"; GKOSChars[30 + 64] = "Õ"; GKOSChars[30 + 128] = "Õ"; //
                                // middle keys 41 39: ì ù
                                GKOSChars[41] = "\u02c6"; GKOSChars[41 + 64] = "\u00a8"; GKOSChars[41 + 128] = "\u02c6"; // combining  ^ on top / ddots /
                                GKOSChars[39] = "ü"; GKOSChars[39 + 64] = "Ü"; GKOSChars[39 + 128] = "Ü"; //
                                // left lower middle key 40: cedilla (SYMB => ü)
                                GKOSChars[40] = "\u00e7"; GKOSChars[40 + 64] = "\u00c7"; GKOSChars[40 + 128] = "\u00c7"; //

                        }

                        break;
           case Language.Ukrainan: // Ukrainian is almost Russian, just replace 4 letters
                        ukrainianVersion = true;

                case Language.Russian: // Russian
                        GKOSChars[1] = "а";// abc
                        GKOSChars[2 + 11 * opt] = "б";
                        GKOSChars[3 + 11 * opt] = "ц";
                        GKOSChars[4 + 23 * opt] = "д";
                        GKOSChars[5] = "е";
                        GKOSChars[6 + 12 * opt] = "ф";
                        GKOSChars[7 + 2 * opt] = "г";// g
                        GKOSChars[8] = "х";
                        GKOSChars[9 - 5 * opt] = "и";
                        GKOSChars[10] = "й";
                        GKOSChars[11 - 8 * opt] = "к";// k
                        GKOSChars[12 + 11 * opt] = "л";
                        GKOSChars[13 - 11 * opt] = "м"; // Was м (opt в)
                        GKOSChars[14 - 3 * opt] = "н";
                        GKOSChars[15] = "о";// o
                        GKOSChars[16] = "п";
                        GKOSChars[17] = "ж";
                        GKOSChars[18 - 12 * opt] = "р";
                        GKOSChars[19] = "с";// s
                        GKOSChars[20 - 13 * opt] = "т";
                        GKOSChars[21] = "у";
                        GKOSChars[22] = "в"; // Was в (opt м)
                        GKOSChars[23 - 3 * opt] = "ш";// w
                        GKOSChars[24] = "ч";
                        GKOSChars[25] = "ы";
                        GKOSChars[26] = "з";

                        GKOSChars[27 - 15 * opt] = "щ";
                        GKOSChars[28] = "ю";
                        GKOSChars[29] = "э";
                        GKOSChars[30] = "я";

                        GKOSChars[39] = "ъ";// lower
                        GKOSChars[40] = "ь";// §
                        GKOSChars[41] = "\u00a8"; // upper two dots above

                        if (ukrainianVersion){ // Ukrainian exceptions to the Russian set
                                GKOSChars[25] = "і"; // Russian ы
                                GKOSChars[29] = "є"; // Russian э
                                GKOSChars[39] = "ь"; // Russian ъ
                                GKOSChars[40] = "ї"; // Russian ь
                                GKOSChars[41] = "ґ"; // Russian upper two dots above
                        }

                        // In addition: v <=> m  =  в <=> м
                        if (opt ==1){
                                GKOSChars[13 - 11 * opt] = "в"; // Was м (opt в)
                                GKOSChars[22] = "м"; // Was в (opt м)
                        }

                        // UPPER CASE
                        for (var i = 0; i < 65; i = i + 64) { // Upper case 65 - 128, CAPS
                                                                                                        // 129 - 191
                                GKOSChars[65 + i] = "А";
                                GKOSChars[66 + i + 11 * opt] = "Б";
                                GKOSChars[67 + i + 11 * opt] = "Ц";
                                GKOSChars[68 + i + 23 * opt] = "Д";
                                GKOSChars[69 + i] = "Е"; // 5
                                GKOSChars[70 + i + 12 * opt] = "Ф"; // 6
                                GKOSChars[71 + i + 2 * opt] = "Г";// G
                                GKOSChars[72 + i] = "Х";
                                GKOSChars[73 + i - 5 * opt] = "И";
                                GKOSChars[74 + i] = "Й"; // 10
                                GKOSChars[75 + i - 8 * opt] = "K";// K
                                GKOSChars[76 + i + 11 * opt] = "Л";
                                GKOSChars[77 + i - 11 * opt] = "М"; // Was М (opt В)
                                GKOSChars[78 + i - 3 * opt] = "Н";
                                GKOSChars[79 + i] = "О";// O 15
                                GKOSChars[80 + i] = "П";
                                GKOSChars[81 + i] = "Ж";
                                GKOSChars[82 + i - 12 * opt] = "Р"; // 18
                                GKOSChars[83 + i] = "С";// S 19
                                GKOSChars[84 + i - 13 * opt] = "Т"; // 20
                                GKOSChars[85 + i] = "У";
                                GKOSChars[86 + i] = "В"; // Was В (opt М)
                                GKOSChars[87 + i - 3 * opt] = "Ш";// W
                                GKOSChars[88 + i] = "Ч";
                                GKOSChars[89 + i] = "Ы"; // 25
                                GKOSChars[90 + i] = "З";
                                GKOSChars[91 + i - 15 * opt] = "Щ";// Ü
                                GKOSChars[92 + i] = "Ю";
                                GKOSChars[93 + i] = "Э";
                                GKOSChars[94 + i] = "Я"; // 30

                                GKOSChars[103 + i] = "Ъ";// lower
                                GKOSChars[104 + i] = "Ь";
                                GKOSChars[105 + i] = "\u00a8"; // two dots above

                                if (ukrainianVersion){ // Ukrainian exceptions to the Russian set
                                        GKOSChars[89 + i] = "І"; // Russian Ы
                                        GKOSChars[93 + i] = "Є"; // Russian Э
                                        GKOSChars[103 + i] = "Ь"; // Russian Ъ
                                        GKOSChars[104 + i] = "Ї"; // Russian Ь
                                        GKOSChars[105 + i] = "Ґ"; // Russian upper two dots above
                                }



                                if (opt == 1) {
                                        GKOSChars[77 + i - 11 * opt] = "В"; // Was М (opt В)
                                        GKOSChars[86 + i] = "М"; // Was В (opt М)
                                }
                        }
                        break;

                case Language.Greek: // Greek
                        GKOSChars[1] = "α"; // abc
                        GKOSChars[2 + 11 * opt] = "ο";
                        GKOSChars[3 + 11 * opt] = "ς";
                        GKOSChars[4 + 23 * opt] = "δ";
                        GKOSChars[5] = "ε";
                        GKOSChars[6 + 12 * opt] = "φ";
                        GKOSChars[7 + 2 * opt] = "γ"; // g
                        GKOSChars[8] = "χ";
                        GKOSChars[9 - 5 * opt] = "η";
                        GKOSChars[10] = "ι"; //
                        GKOSChars[11 - 8 * opt] = "κ"; // k
                        GKOSChars[12 + 11 * opt] = "λ";
                        GKOSChars[13 - 11 * opt] = "μ";
                        GKOSChars[14 - 3 * opt] = "ν";
                        GKOSChars[15] = "ω"; // o
                        GKOSChars[16] = "π"; //
                        GKOSChars[17] = "ψ";
                        GKOSChars[18 - 12 * opt] = "ρ";
                        GKOSChars[19] = "σ"; // s
                        GKOSChars[20 - 13 * opt] = "τ";
                        GKOSChars[21] = "ου";
                        GKOSChars[22] = "β";
                        // GKOSChars[23] = "́"; //w (acute)
                        GKOSChars[23 - 3 * opt] = "\u0301"; // (acute)
                        GKOSChars[24] = "ξ";
                        GKOSChars[25] = "υ";
                        GKOSChars[26] = "ζ";

                        GKOSChars[27 - 15 * opt] = "θ";
                        GKOSChars[28] = "ϑ"; // technical symbol script theta
                        GKOSChars[29] = "ει";
                        GKOSChars[30] = "\u03d2"; // ϒ (U+03D2) technical symbol upsilon //
                                                                                // Does not work: ϕ (U+03D5) technical
                                                                                // symbol phi (does not work)

                        GKOSChars[39] = "\u00a8"; // lower two dots above
                        GKOSChars[40] = "§"; // §
                        // GKOSChars[41] = "\u005e"; //upper inv. v above (BIG)
                        GKOSChars[41] = "\u02c6"; // (small)


                        if (opt == 1) {

                                // ο <=> ω
                                GKOSChars[2 + 11 * opt] = "ω";
                                GKOSChars[15] = "ο"; // o
                                // Ι <=> Λ / ι <=> λ
                                GKOSChars[10] = "λ"; //
                                GKOSChars[12 + 11 * opt] = "ι";
                                // Π <=> Δ / π <=> δ
                                GKOSChars[16] = "δ"; //
                                GKOSChars[4 + 23 * opt] = "π";
                        }

                        // UPPER CASE and CAPS

                        for (var i = 0; i < 65; i = i + 64) { // Upper case 65 - 128, CAPS
                                                                                                        // 129 - 191
                                GKOSChars[65 + i] = "Α"; // 1
                                GKOSChars[66 + i + 11 * opt] = "Ο";
                                GKOSChars[67 + i + 11 * opt] = "ς";
                                GKOSChars[68 + i + 23 * opt] = "Δ";
                                GKOSChars[69 + i] = "Ε"; // 5
                                GKOSChars[70 + i + 12 * opt] = "Φ";
                                GKOSChars[71 + i + 2 * opt] = "Γ"; // G
                                GKOSChars[72 + i] = "Χ";
                                GKOSChars[73 + i - 5 * opt] = "Η";
                                GKOSChars[74 + i] = "Ι"; // 10
                                GKOSChars[75 + i - 8 * opt] = "Κ"; // K
                                GKOSChars[76 + i + 11 * opt] = "Λ";
                                GKOSChars[77 + i - 11 * opt] = "Μ";
                                GKOSChars[78 + i - 3 * opt] = "Ν";
                                GKOSChars[79 + i] = "Ω"; // O 15
                                GKOSChars[80 + i] = "Π";
                                GKOSChars[81 + i] = "Ψ";
                                GKOSChars[82 + i - 12 * opt] = "Ρ";
                                GKOSChars[83 + i] = "Σ"; // S
                                GKOSChars[84 + i - 13 * opt] = "Τ"; // 20
                                GKOSChars[85 + i] = "Ου";
                                GKOSChars[86 + i] = "Β";
                                // GKOSChars[87+i]= "́"; // W acute
                                GKOSChars[87 + i - 3 * opt] = "\u0300"; // W grave (Shift)
                                GKOSChars[88 + i] = "Ξ";
                                GKOSChars[89 + i] = "Υ"; // 25
                                GKOSChars[90 + i] = "Ζ";

                                GKOSChars[91 + i - 15 * opt] = "Θ"; // Ü
                                GKOSChars[92 + i] = "ϑ"; // technical symbol script theta //
                                                                                        // Does not work: ="\u03f5"; // ϵ
                                                                                        // (U+03F5) technical symbol epsilon
                                GKOSChars[93 + i] = "Ει";
                                GKOSChars[94 + i] = "\u03d2"; // ϒ (U+03D2) technical symbol
                                                                                                // upsilon

                                GKOSChars[103 + i] = "\u00a8"; // lower, two dots above
                                GKOSChars[104 + i] = "§";
                                GKOSChars[105 + i] = "\u005e"; // upper, inv. v above

                                if (opt == 1) {

                                        // ο <=> ω / Ο <=> Ω
                                        GKOSChars[66 + i + 11 * opt] = "Ω";
                                        GKOSChars[79 + i] = "Ο"; // O 15
                                        // Ι <=> Λ / ι <=> λ
                                        GKOSChars[74 + i] = "Λ"; // 10
                                        GKOSChars[76 + i + 11 * opt] = "Ι";
                                        // Π <=> Δ / π <=> δ
                                        GKOSChars[80 + i] = "Δ";
                                        GKOSChars[68 + i + 23 * opt] = "Π";

                                }

                        }
                        // CAPS ONLY:

                        GKOSChars[85 + 64] = "ΟΥ";
                        GKOSChars[87 + 64] = "\u0301"; // W acute (CAPS)

                        GKOSChars[92 + 64] = "ϑ"; // technical symbol script theta // Does
                                                                                // not work: "\u03f5"; // ϵ (U+03F5)
                                                                                // technical symbol epsilon
                        GKOSChars[93 + 64] = "ΕΙ";
                        GKOSChars[94 + 64] = "\u03d2"; // ϒ (U+03D2) technical symbol
                                                                                        // upsilon // Does no work: =
                                                                                        // "\u03d5"; // ϕ (U+03D5) technical
                                                                                        // symbol phi


                                    break;

                case Language.Malay:

                    GKOSChars[27] = "u"; // (redundant common u in alpha mode)
                    GKOSChars[27 + 64] = "U";
                    GKOSChars[27 + 128] = "U"; // Alphabetic layout

                    if (opt == 1)
                    {
                        setBasicOptimisation(); // other than English

                        // Malay special: o (15) <=> p (16)

                        GKOSChars[15] = "p";
                        GKOSChars[15 + 64] = "P";
                        GKOSChars[15 + 128] = "P";
                        GKOSChars[16] = "o";
                        GKOSChars[16 + 64] = "O";
                        GKOSChars[16 + 128] = "O";

                        GKOSChars[12] = "apakah "; // a (whether) keyL
                        GKOSChars[12 + 64] = "Apakah ";
                        GKOSChars[12 + 128] = "APAKAH ";

                        GKOSChars[40] = "dengan "; // s/§ (with)
                        GKOSChars[40 + 64] = "Dengan ";
                        GKOSChars[40 + 128] = "DENGAN ";

                    }

                    // Malay special (same for both opt and alpha):
                    // d pressed / Right column: 28, 41, 29, 39, 30
                    //                            i   t   e   n   r

                    GKOSChars[28] = "aku "; // d (I)
                    GKOSChars[28 + 64] = "Aku ";
                    GKOSChars[28 + 128] = "AKU ";
                    GKOSChars[41] = "telah "; // t (has)
                    GKOSChars[41 + 64] = "Telah ";
                    GKOSChars[41 + 128] = "TELAH ";
                    GKOSChars[29] = "yang "; // e (that)
                    GKOSChars[29 + 64] = "Yang ";
                    GKOSChars[29 + 128] = "YANG ";
                    GKOSChars[39] = "tidak "; // n (not)
                    GKOSChars[39 + 64] = "Tidak ";
                    GKOSChars[39 + 128] = "TIDAK ";
                    GKOSChars[30] = "kau "; // r (you)
                    GKOSChars[30 + 64] = "Kau ";
                    GKOSChars[30 + 128] = "KAU ";

                    break;





                                // 0, 64, 129, 192, 256      = abc, Abc, ABC, 123, SYMB
                                // 0, 64, 129, 192, 256, 320 = abc, Abc, ABC, 123, SYMB, Hangul (한글)

//	TODO: Uncomment when adding Korean
        case Language.Korean:
                //java.util.Locale.setDefault(java.util.Locale.KOREA);
                        // Unicode range	Android
                        // U+AC00 to U+D7A3,	OK, syllable	(Hangul Syllables)
                        // U+1100 to U+11FF,	no output		(Hangul Jamo) - only for indexing
                        // U+3131 to U+318E,	OK, letter		(Hangul Compatibility Jamo)
                        // U+FFA1 to U+FFDC		no output		(Halfwidth and Fullwidth Forms)
                         //char charKor = 'ㅏ';
                         //int unicodeKor = charKor;

                // AuxSet1 abc (Lower case)

                                // AUXSET is used for Korean characters and all other sets are the
                                // same as the previously used set (depending on latest Language).
                                // abc => 123 => Korean => abc etc., by pressing abc123 (SPACE+Backspace)
                                // GKOSChars referred by 321...383, Korean jamos referred by 1...63
                                var k = 320;
                                // var k = 0; // test only !!!
                                GKOSChars[1+k]= "ㅏ";  medJamo[1] = 0x1161; //"\u1161"; //a
                                GKOSChars[2+k]= "ㅡ";   medJamo[2] = 0x1173; //"\u1173";
                                GKOSChars[3+k]= "ㅓ";   medJamo[3] = 0x1165; //"\u1165";
                                GKOSChars[4+k]= "ㅜ";   medJamo[4] = 0x116e; //"\u116e";
                                GKOSChars[5+k]= "ㅣ";  medJamo[5] = 0x1175; //"\u1175";
                                GKOSChars[6+k]= "ㅗ";   medJamo[6] = 0x1169; //"\u1169";

                                GKOSChars[7+k]= "ㅎ";  initJamo[7] = 0x1112;  medJamo[7] = 0x1162; finJamo[7] = 0x11c2;//"\u1112" //g
                                GKOSChars[8+k]= "ㅋ";  initJamo[8] = 0x110f; finJamo[8] = 0x11bf; //"\u110f";
                                GKOSChars[9+k]= "ㄱ";  initJamo[9] = 0x1100;  medJamo[9] = 0x1168; finJamo[9] = 0x11a8; //"\u1100"; //dec 4352
                                GKOSChars[10+k]= "ㄲ"; initJamo[10] = 0x1101; finJamo[10] = 0x11a9;  //"\u1101";

                                GKOSChars[11+k]= "ㄴ";  initJamo[11] = 0x1102;  medJamo[11] = 0x1166; finJamo[11] = 0x11ab;//"\u1102" //k
                                GKOSChars[12+k]= "ㅊ";  initJamo[12] = 0x110e; finJamo[12] = 0x11be; //"\u110e";
                                GKOSChars[13+k]= "ㅈ";  initJamo[13] = 0x110c;  medJamo[13] = 0x1170; finJamo[13] = 0x11bd; //"\u110c";
                                GKOSChars[14+k]= "ㅉ";  initJamo[14] = 0x110d; finJamo[14] = 0x11bd; //Previous, no final "\u110d";

                                GKOSChars[15+k]= "ㅇ";  initJamo[15] = 0x110b;  medJamo[15] = 0x116a; finJamo[15] = 0x11bc; //"\u110b" //o
                                GKOSChars[16+k]= "ㅍ";  initJamo[16] = 0x1111; finJamo[16] = 0x11c1; //"\u1106";
                                GKOSChars[17+k]= "ㅂ";  initJamo[17] = 0x1107;  medJamo[17] = 0x116c; finJamo[17] = 0x11b8; //"\u1107";
                                GKOSChars[18+k]= "ㅃ";  initJamo[18] = 0x1108; finJamo[18] = 0x11b8; //Previous, no final "\u1108";

                                GKOSChars[19+k]= "ㅁ";  initJamo[19] = 0x1106;  medJamo[19] = 0x116f; finJamo[19] = 0x11b7; //"\u1106" //s
                                GKOSChars[20+k]= "ㅌ";  initJamo[20] = 0x1110; finJamo[20] = 0x11c0; //"\u1110";
                                GKOSChars[21+k]= "ㄷ";  initJamo[21] = 0x1103;  medJamo[21] = 0x1171; finJamo[21] = 0x11ae; //"\u1103";
                                GKOSChars[22+k]= "ㄸ";  initJamo[22] = 0x1104; finJamo[22] = 0x11ae; //Previous, no final "\u1104";

                                //GKOSChars[23]= ""; // String.valueOf((char) codePoint); //w
                                GKOSChars[23+k]= "\u21e8"; // Next Syllable //w
                                GKOSChars[24+k]= "ㅑ";   medJamo[24] = 0x1163; //"\u1163"; (jaa)
                                GKOSChars[25+k]= "ㅅ";  initJamo[25] = 0x1109;  medJamo[25] = 0x1164; finJamo[25] = 0x11ba; //"\u1109";
                                GKOSChars[26+k]= "ㅕ";  medJamo[26] = 0x1167;  //"\u1167"; (jöö)

                                GKOSChars[27+k]= "ㄹ"; initJamo[27] = 0x1105;  medJamo[27] = 0x1174; finJamo[27] = 0x11af;  //"\u1105"; //th
                                GKOSChars[28+k]= "ㅠ";  medJamo[28] = 0x1172; //"\u1172";  (juu)
                                GKOSChars[29+k]= "ㅆ";  initJamo[29] = 0x110a;  medJamo[29] = 0x1168; finJamo[29] = 0x11bb; //"\u110a";
                                GKOSChars[30+k]= "ㅛ";   medJamo[30] = 0x116d; //"\u116d"; (joo)

                                GKOSChars[39+k]="ㅔ";  medJamo[39] = 0x1166;// "\u1165"; // and, e (ee), redundant on purpose
                                GKOSChars[41+k]="ㅐ";  medJamo[41] = 0x1162; // "\u1161"; // to, ae (ää), redundant on purpose
                                GKOSChars[40+k]="ㅘ";  medJamo[40] = 0x116a;// "\u1175"; // with


                // AuxSet2 Abc	(Shift)

                                // This is for having Korean double tail consonants available by Shift
                                // AUXSET2 (384...448) is used for these double tail consonsonants
                                // 384 = NULL, 385 = ...
                                        i = 320; j = 0;
                                        GKOSChars[65+i]="ㄾ"; finJamo[65+j] = 0x11b4;//ㄾ "\u11b4";
                                        GKOSChars[66+i]="ㄽ"; finJamo[66+j] = 0x11b3;// "\u11b3";
                                        GKOSChars[67+i]="ㄺ"; finJamo[67+j] = 0x11b0;// "\u11b0";

                                        GKOSChars[68+i]="ㄿ"; finJamo[68+j] = 0x11b5;//ㄿ "\u11b5";
                                        GKOSChars[69+i]="ㄼ"; finJamo[69+j] = 0x11b2;//ㄼ "\u11b2";
                                        GKOSChars[70+i]="ㅄ"; initJamo[70+j] = 0x1121;finJamo[70+j] = 0x11b9;// "\u11b9";

                                        GKOSChars[71+i]="ㄶ"; initJamo[71+j] = 0x115d; finJamo[71+j] = 0x11ad;// ㄶ // G
                                        GKOSChars[72+i]="★"; // "\u118f";
                                        GKOSChars[73+i]="☆";initJamo[73+j] = 0x115c; finJamo[73+j] = 0x11ac; //ㄵ "\u11ac";
                                        GKOSChars[74+i]="\u260e"; // "\u11a9";

                                        GKOSChars[75+i]="ㄵ";initJamo[75+j] = 0x115c; finJamo[75+j] = 0x11ac; // "\u11ac"; //K
                                        GKOSChars[76+i]="♪"; // "\u11c0";
                                        GKOSChars[77+i]="♩";// "\u11ae";
                                        GKOSChars[78+i]="♬";// "\u11c8"; //??

                                        GKOSChars[79+i]="ㅀ"; finJamo[79+j] = 0x11b6;//ㅭ => ㅀ // O
                                        GKOSChars[80+i]="♥"; finJamo[80+j] = 0x11aa;//ㄳ "\u11a8"; ♥ ♡ ♪ ♩ ♬  ※ ★ ☆
                                        GKOSChars[81+i]="♡"; initJamo[81+j] = 0x1121;finJamo[81+j] = 0x11b9;// ㅄ"\u11b9";
                                        GKOSChars[82+i]="∞"; // "※" //initJamo[82+j] = 0x115b; finJamo[82+j] = 0x11c7;//ㅧ "\u11c7";

                                        GKOSChars[83+i]="ㄻ"; finJamo[83+j] = 0x11b1;//ㄻ "\u11b1"; // S
                                        GKOSChars[84+i]="\u2640";initJamo[84+j] = 0x115b; finJamo[84+j] = 0x11c7;//ㅧ "\u11c7";
                                        GKOSChars[85+i]="\u2642";initJamo[85+j] = 0x115c; finJamo[85+j] = 0x11ac; //ㄵ "\u11ac";
                                        GKOSChars[86+i]="\u2668"; initJamo[86+j] = 0x11ff; finJamo[86+j] = 0x11ff;// Not supported: Korean Won ₩ "\u20a9";

                                        GKOSChars[87+i]="\u21e8"; // Next Syllable // W
                                        GKOSChars[88+i]="\u00ab"; // Left angle quote
                                        GKOSChars[89+i]="《"; finJamo[89+j] = 0x11ff;//ㄺ "\u11b0";
                                        GKOSChars[90+i]=""; medJamo[90+j] = 0x11b0;//"\u11b3";

                                        GKOSChars[91+i]="ㄳ"; finJamo[91+j] = 0x11aa;//ㄳ "\u11a8"; // TH
                                        GKOSChars[92+i]="\u00bb"; // Right angle quote // That
                                        GKOSChars[93+i]="》"; finJamo[93+j] = 0x11ff;//ㄼ "\u11b2"; // The
                                        GKOSChars[94+i]="ㆍ"; medJamo[94+j] = 0x119e;// ㆍ  // of

                                        GKOSChars[103+i]=""; finJamo[103+j] = 0x1100;//empty; // and
                                        GKOSChars[105+i]=""; finJamo[105+j] = 0x11ff;//empty; // to
                                        GKOSChars[104+i]=""; finJamo[104+j] = 0x1100;//empty; // with
                                        GKOSChars[122+i]="\u00b0"; finJamo[122+j] = 0x11ff;//Degree sign at Del; // Del

                // AuxSet3 ABC (Caps)

                                // Not used in Korean (default AuxSet3 will be English CAPS)
                                // TODO: move the korean set special characters here, now they are in defaults!

                                        break;

                } // end of switch

                // Common settings to all languages



        }

// ======================================================================================

/*
        var gChordToRef[] = { 0, 1, 2, 15, 3, 27, 19, 46, 4, 42, 36,
                        16, 33, 28, 20, 47, 5, 35, 59, 17, 32, 29, 21, 48, 7, 8, 9, 44, 10,
                        41, 38, 56, 6, 34, 31, 18, 43, 30, 22, 49, 23, 24, 25, 58, 26, 60,
                        40, 62, 11, 12, 13, 37, 14, 39, 45, 63, 50, 51, 52, 54, 53, 55, 57,
                        61 };

        public static final int NONE = 0;

        public static final int A = 0x01;
        public static final int B = 0x02;
        public static final int C = 0x04;
        public static final int D = 0x08;
        public static final int E = 0x10;
        public static final int F = 0x20;

        public static final int O = A + B;
        public static final int S = B + C;
        public static final int G = D + E;
        public static final int K = E + F;
        public static final int TH = A + C;
        public static final int W = D + F;

        public static final int BACKSPACE = A + B + C;
        public static final int SPACE = D + E + F;

        public static final int SHIFT_MODIFIER = 0x40;
        public static final int CAPS_MODIFIER = 0x80;
        public static final int NUMBER_MODIFIER = 0xc0;
        public static final int SYMBOL_MODIFIER = 0x100;
        public static final int AUXSET_MODIFIER = 0x140;
        public static final int AUXSET2_MODIFIER = 0x180;
        public static final int AUXSET3_MODIFIER = 0x1c0;
        //public static final int HANGUL_MODIFIER = 0x140;

        public static final int MODIFIER_MASK = 0x1c0;
        public static final int ALL_BUTTONS = SPACE + BACKSPACE;

        public static int mirror(int chord) {
                if (chord < D)
                        return chord * 8;
                else
                        return chord / 8;
        }

        public static boolean isOnTheSameSide(int state, int key) {
                if (state == NONE)
                        return false;
                return (state < D && key < D) || (state >= D && key >= D);
        }

        public static boolean isButtonSymbolHidden(int state, int key) {
                if (state == NONE)
                        return false;
                boolean sameSide = isOnTheSameSide(state, key);
                if (sameSide) {
                        return true;
                } else {
                        if (isComboButton(key))
                                return true;
                }
                return false;
        }

        public static boolean isComboButton(int key) {
                switch (key) {
                case TH:
                case W:
                case BACKSPACE:
                case SPACE:
                        return true;
                }
                return false;
        }

        public static int mirrorIfOnTheSameSide(int state, int chord) {
                if (state == 0)
                        return chord;

                if ((state < D && chord < D) || (state >= D && chord >= D)) {
                        return mirror(chord);
                } else
                        return chord;
        }
*/
        /**
         * Checks that two button presses do not overlap (ie. pressing a with o,
         * which already includes a).
         *
         * @param chord1
         * @param chord2
         * @return
         */
/*
public static boolean isValidCombination(int chord1, int chord2) {
                return (chord1 & chord2) == 0;
        }
*/
        /***
         * Checks that the modifier and chord only have the relevant bits set
         *
         * @param modifier
         * @param chord
         * @return
         */
/*
        public static boolean isValidChord(int modifier, int chord) {
                return ((chord & ALL_BUTTONS) == chord && (modifier & MODIFIER_MASK) == modifier);
        }

        public static String getStringRepresentation(int modifier, int chord) {
                if (!isValidChord(modifier, chord))
                        throw new IllegalArgumentException("Invalid modifier and chord: "
                                        + modifier + " " + chord);

                return GKOSChars[modifier + gChordToRef[chord]];
        }
*/
        function setBasicOptimisation(){
                // this is the basic optimised layout for other languages than English
                GKOSChars[13] = "b"; GKOSChars[13 + 64] = "B"; GKOSChars[13 + 128] = "B"; // b <=> m
                GKOSChars[2] = "m"; GKOSChars[2 + 64] = "M"; GKOSChars[2 + 128] = "M";
                GKOSChars[8] = "h"; GKOSChars[8 + 64] = "H"; GKOSChars[8 + 128] = "H";

                GKOSChars[14] = "c"; GKOSChars[14 + 64] = "C"; GKOSChars[14 + 128] = "C"; // c <=> k
                GKOSChars[3] = "k"; GKOSChars[3 + 64] = "K"; GKOSChars[3 + 128] = "K";

                GKOSChars[12] = "\u00fc"; GKOSChars[12 + 64] = "\u00c5"; GKOSChars[12 + 128] = "\u00c5"; // th/ü <=> d
                GKOSChars[27] = "d"; GKOSChars[27 + 64] = "D"; GKOSChars[27 + 128] = "D"; // German/Swedish
                //GKOSChars[27] = "ä"; GKOSChars[27 + 64] = "Ä"; GKOSChars[27 + 128] = "Ä"; // Finnish

                GKOSChars[20] = "w"; GKOSChars[20 + 64] = "W"; GKOSChars[20 + 128] = "W"; // w <=> l
                GKOSChars[23] = "l"; GKOSChars[23 + 64] = "L"; GKOSChars[23 + 128] = "L";

        }

        function setUmlautLayout() {
                // abc, Abc, ABC, 123, SYMB
                //   0   64  128  192  256
                // Basic common settings for German/Swedish/Finnish
                GKOSChars[28] = "\u00e5"; // å
                GKOSChars[28 + 64] = "\u00c5";
                GKOSChars[28 + 128] = "\u00c5"; // that

                GKOSChars[30] = "\u00f6"; // ö
                GKOSChars[30 + 64] = "\u00d6";
                GKOSChars[30 + 128] = "\u00d6"; // of
                // ---
                GKOSChars[39] = "\u00a8"; // "\u0308"; // combining diaresis U+0308 ( ̈ ) //and
                GKOSChars[39 + 64] = "\u0300"; // Grave
                GKOSChars[39 + 128] = "\u00a8"; // combining diaeresis U+0308 ( ̈ ) // and
                GKOSChars[39 + 192] = "\u00b5"; // NUM: micro sign (and)

                GKOSChars[40] = "\u00df"; // Double s
                GKOSChars[40 + 64] = "\u0301"; // Acute
                GKOSChars[40 + 128] = "\u00df"; //
                GKOSChars[40 + 192] = "\u00a7"; // NUM: section sign  (with)

                GKOSChars[41] = "\u02c6"; // "\u030c" = combining caron = ̌  (to )
                GKOSChars[41 + 64] = "\u02C7"; //SHIFT: inv v on top = (̂ ) = circumflex
                GKOSChars[41 + 128] = "\u02C6"; // CAPS: combining caron U+030C ( ̌ )
                GKOSChars[41 + 192] = "\u007e"; // NUM: Tilde ~ (small 02dc, bigger 007e)
                GKOSChars[41 + 256] = "\u02c6"; // SYMB: v on top

                GKOSChars[57 + 256] = "\u00ba"; // SYMB/Ins: Degree sign (also 02da is but smaller)

        }


// ====================== Korean Combiner ================================================

// STATUS quite ok, some cleaning needed

// KeyboardView.OnKeyboardActionListener output;

var jamoCounter = 0;
var prevCodePoint; // code point of previous syllable
var codePoint; // code point of present syllable
var codePoint2; // present code point after stealing from previous syllable (last jamo)
var prevJamoChar1 = 0x1100; // default
var prevMedJamoChar1 = 0x1161; // default
//var prevJamoChar1ref = 0; // default
var prevJamoChar2 = 0x1161; // default
//var prevJamoChar2ref = 0; // default
var prevJamoChar3 = 0x11a7; // default
var prevJamoChar3ref = 0; // default
var previousSyllable = 0; // codepoint of prev.syllable
var JamoChar1ref = 0;
var JamoChar2ref = 0;
var JamoChar3ref = 0;
var JamoChar1 = 0x1100; // default
var JamoChar2 = 0x1161; // default
var JamoChar3 = 0x11a7; // default
var wipeString = "";
var fillString = ""; // possible mute character for single vowels
var vowelLayoutMode = false;


function getKoreanCombinedCharacter(c, gChord, kOffset) {
// returns the combo as astring

         console.log("From GKOSKeyboard to combiner: " + c);

        var combined = c; // string

        fillString = ""; // default mute character

        // gChord => ref => jamos gChordToRef[]
      // Android:  var refA = GSets.gChordToRef[gChord] + kOffset;
        var refA = gChordToRef[gChord] + kOffset;
        var ref = refA;

        // All GKOSChars ref: 1...384 (= 320 + 64),
        // jamos referred by 1...63 (auxset), double tail consonants by 65...127 (auxset2)

        // Remove offset from ref (321... => 1...)
        if (refA > 320){ref = refA - 320;}

        if (c == "_BS"){ // Backspace pressed
                forgetOldSyllable();
                startNewSyllable();
                return ""; // Nothing given here will be output anyway
        }

        if ((c == "_Enter") || (c == " ")) { // Reset Syllable building also when Enter pressed
                fixOrphanVowel();
                forgetOldSyllable();
                startNewSyllable();
                return c; // Only Space given here will be output
        }

        if (refA < 320) { // Only combine Korean characters
                fixOrphanVowel();
                forgetOldSyllable();
                startNewSyllable();
                return wipeString + fillString + c; // Not within aux or aux2 set
        }

        if (c == "\u21e8") { // "New Syllable" (="NEXT") pressed
                fixOrphanVowel();
                forgetOldSyllable();
                startNewSyllable();
                return wipeString + fillString + "";
        }


        jamoCounter = jamoCounter + 1;


        switch (jamoCounter) {

        case 1:

                // ********** jamoCounter = 1 **********

            console.log("Ref: " + ref);

            // Android:    JamoChar1 = GSets.initJamo[ref];// Yes.
            JamoChar1 = initJamo[ref];// Yes.
                                        JamoChar1ref = ref;
                JamoChar2 = 0x1161; // default
                JamoChar3 = 0x11a7; // default
                wipeString = "";

                // Within Leading consonant (L) bounds?
                // ====================================
        if (((JamoChar1 - 0x1100) >= 0) && (JamoChar1 - 0x1100) < 19){
                        // Yes.
                        //combined = c; // Test
                        combined = GKOSChars[ref + 320]; // move back to Korean set area (+320)
                        wipeString = "";

                        if (prevMedJamoChar1 > 0x1160){ // Previous single vowel exists?
                                fillString = String.fromCharCode((((0x110b - 0x1100)*21 + (prevMedJamoChar1 - 0x1161))*28 + 0xac00));
                                wipeString = "<";
                                prevMedJamoChar1 = 0x1160; // default
                                }


                        // showVowelLayout //
                        showVowelLayout();


                        break;

                } else {

                        // Within Vowel (V) bounds then?
                        // ============================
                        if ((medJamo[ref] - 0x1161) >= 0 && ((medJamo[ref] - 0x1161) < 21)) {
                        // Steal the last consonant from the previous syllable then!

                                if ((previousSyllable >= 0xa000) && (prevJamoChar3ref < 64)){ // Previous syllable exists and is not double tail consonant
                                // TODO: Check this value 0xa000 !!!! In fact, 0xac00 is where syllables start (with 2 or 3 jamos) - Test that!

                                // Build a new syllable from that consonant and the new vowel
                                JamoChar1 = initJamo[prevJamoChar3ref]; // new start of syllable
                                JamoChar2 = medJamo[ref]; // new start of syllable

                                codePoint = ((prevJamoChar1 - 0x1100)*21 + (prevJamoChar2 - 0x1161))*28 + 0xac00; // The updated previous Syllable
                                codePoint2 = ((JamoChar1 - 0x1100)*21 + (JamoChar2 - 0x1161))*28 + 0xac00; // Starting the new Syllable

                                //combined = String.valueOf((char) codePoint) + GKOSChars[ref]; // Need codePoint here too!
                                // Android: combined = String.valueOf((char) codePoint) + String.valueOf((char) codePoint2 );
                                    combined = String.fromCharCode(codePoint) + String.fromCharCode(codePoint2); // Qt javascript version
                                wipeString = "<"; // BackSpace
                                    // TO TRY: (String.fromCharCode(value))

                                // Forget the previous Syllable
                                forgetOldSyllable(); //
                                // prevJamoChar1 = 0x1100;
                                //prevJamoChar1 = JamoChar1; // Have to save this in case of a single vowel (fill needed)
//					prevJamoChar2 = 0x1161; // default
//					prevJamoChar3 = 0x11a7; // default
//					prevJamoChar3ref = 0; // default
//					previousSyllable = 0;
                            jamoCounter = 2; // We already have the first two Jamos in the new Syllable now
                                break;

                                } else { // Previous syllable does not exist, may be a single vowel
                                        //
                                        //combined = "X" + c; // X = Debug: Previous Syllable does not exist *************
                                        combined = c; // Normal

                                        fixOrphanVowel();

                                        forgetOldSyllable(); //
                                        jamoCounter = 0; // start a new syllable
                                        prevMedJamoChar1 = medJamo[ref]; // Have to save this vowel in case of a single vowel (fill needed)
                                        break;
                                        //
                                                }
                                }
                }
                // Neither Consonant nor Vowel, must be other symbol (abc, 123, ...)
                //
                jamoCounter = 0; // start a new syllable
                //combined = "A" + c; // A = Debug: Not Consonant, not Vowel *********
                combined = c; // Normal
                wipeString = "";
                forgetOldSyllable();
                startNewSyllable();
                //

        break;


        case 2:

                // ********** jamoCounter = 2 **********

                JamoChar2 = medJamo[ref];
                JamoChar2ref = ref;

                // Within Vowel (V) bounds?
                // ========================
                if ((JamoChar2 - 0x1161) >= 0 && ((JamoChar2 - 0x1161) < 21)) {

                        JamoChar3 = 0x11a7; // defaults, time to forget the previous Syllable
                        prevJamoChar3ref = 0;
                        previousSyllable = 0;

                        //if (((JamoChar1 - 0x1100) > 0) && ((JamoChar1 - 0x1100) < 19) && ((JamoChar2 - 0x1161) > 0) && ((JamoChar2 - 0x1161) < 21)) {
                        codePoint = ((JamoChar1 - 0x1100)*21 + (JamoChar2 - 0x1161))*28 + (JamoChar3 - 0x11a7) + 0xac00;
                        combined = String.fromCharCode(codePoint);
                        wipeString = "<"; // BackSpace
                        //GKOSKeyboardActivity.keyUpDown(KeyEvent.KEYCODE_DEL);


                } else {
                        //combined = "B" + c; // B = Debug: Not a Vowel. **************
                        combined = c; // Normal. Just output the Jamo.
                        forgetOldSyllable();
                        startNewSyllable();
                        jamoCounter = 0; // A fresh start next.

                                // Within (new) Leading consonant bounds, however?
                                // ===============================================
                                if (((initJamo[ref] - 0x1100) >= 0) && (initJamo[ref] - 0x1100) < 19){
                                        // Yes.
                                        //combined = "N" + c; // N = Debug: New Initial Consonant ************
                                        combined = c; // Normal
                                        jamoCounter = 1; // We have a new Initial Consonant here
                                        JamoChar1 = initJamo[ref];



                                }

                }

                showMixedLayout();
        break;


        case 3:

                // ********** jamoCounter = 3 **********

                JamoChar3 = finJamo[ref];
                JamoChar3ref = ref;

                // Within Trailing consonant (T) bounds?
                // =====================================
                if ((JamoChar3 - 0x11a7) >= 0 && (JamoChar3 - 0x11a7) < 28) {  // Yes.
                        codePoint = ((JamoChar1 - 0x1100)*21 + (JamoChar2 - 0x1161))*28 + (JamoChar3 - 0x11a7) + 0xac00;
                        combined = String.fromCharCode(codePoint);

                        jamoCounter = 0; // A fresh start next.

                        prevJamoChar1 = JamoChar1; // save these in case last consonant needs to be removed later
                        prevJamoChar2 = JamoChar2;
                        prevJamoChar3 = JamoChar3;
                        prevJamoChar3ref = JamoChar3ref;
                        previousSyllable = codePoint; // save this as the previous syllable codepoint

                        wipeString = "<"; // BackSpace

                } else { // Not within T bounds
                        // Then it is a vowel or it is part of the next Syllable.

                    // Vowel:
                        // In case of a vowel, check if it will become part of a new vowel composed of two.

                        // Within vowel bounds?
                        // ====================
                        if ((medJamo[JamoChar3ref] - 0x1161) >= 0 && ((medJamo[JamoChar3ref] - 0x1161) < 21)) {
                        // Yes, a vowel.

                                // Android: boolean comboVowel = false; // Default
                            var comboVowel = false; // Default

                                // Allowed combined vowels:
                                if ((JamoChar2 == 0x1161) && (medJamo[JamoChar3ref] == 0x1175)){JamoChar2 = 0x1162; JamoChar3 = 0x11a7; comboVowel = true;} // a + i
                                if ((JamoChar2 == 0x1163) && (medJamo[JamoChar3ref] == 0x1175)){JamoChar2 = 0x1164; JamoChar3 = 0x11a7; comboVowel = true;} // ja + i
                                if ((JamoChar2 == 0x1165) && (medJamo[JamoChar3ref] == 0x1175)){JamoChar2 = 0x1166; JamoChar3 = 0x11a7; comboVowel = true;} // ö + i
                                if ((JamoChar2 == 0x1167) && (medJamo[JamoChar3ref] == 0x1175)){JamoChar2 = 0x1168; JamoChar3 = 0x11a7; comboVowel = true;} // jö + i

                                if ((JamoChar2 == 0x1169) && (medJamo[JamoChar3ref] == 0x1175)){JamoChar2 = 0x116c; JamoChar3 = 0x11a7; comboVowel = true;} // o + i
                                if ((JamoChar2 == 0x116e) && (medJamo[JamoChar3ref] == 0x1175)){JamoChar2 = 0x1171; JamoChar3 = 0x11a7; comboVowel = true;} // u + i
                                if ((JamoChar2 == 0x1173) && (medJamo[JamoChar3ref] == 0x1175)){JamoChar2 = 0x1174; JamoChar3 = 0x11a7; comboVowel = true;} // y + i
                                //
                                if ((JamoChar2 == 0x1169) && (medJamo[JamoChar3ref] == 0x1161)){JamoChar2 = 0x116a; JamoChar3 = 0x11a7; comboVowel = true;} // o + ä
                                if ((JamoChar2 == 0x1169) && (medJamo[JamoChar3ref] == 0x1162)){JamoChar2 = 0x116b; JamoChar3 = 0x11a7; comboVowel = true;} // u + e

                                if ((JamoChar2 == 0x116e) && (medJamo[JamoChar3ref] == 0x1165)){JamoChar2 = 0x116f; JamoChar3 = 0x11a7; comboVowel = true;} // o + a
                                if ((JamoChar2 == 0x116e) && (medJamo[JamoChar3ref] == 0x1166)){JamoChar2 = 0x1170; JamoChar3 = 0x11a7; comboVowel = true;} // u + ö
                                // Combo of three vowels (the second and last of previous four typed as three single Jamos)
                                if ((JamoChar2 == 0x116a) && (medJamo[JamoChar3ref] == 0x1175)){JamoChar2 = 0x116f; JamoChar3 = 0x11a7; comboVowel = true;} // o + a
                                if ((JamoChar2 == 0x116f) && (medJamo[JamoChar3ref] == 0x1175)){JamoChar2 = 0x1170; JamoChar3 = 0x11a7; comboVowel = true;} // u + ö

                                  if (comboVowel){
                                         // Combined vowel within syllable, TODO: outside syllable then?
                                        codePoint = ((JamoChar1 - 0x1100)*21 + (JamoChar2 - 0x1161))*28 + (JamoChar3 - 0x11a7) + 0xac00;
                                        combined = String.fromCharCode(codePoint);
                                        jamoCounter = 2;
                                        wipeString = "<"; // BackSpace
                                        //((GKOSKeyboardActivity)output).keyUpDown(KeyEvent.KEYCODE_DEL);

                // See GKOSKeyboard.java Line 155 !!!!! things to do !!!!! (Android version)

                                  } else { // Cannot combine the vowels
                                        // Leave syllable and make a separate vowel next
                                        //combined = "C" + c; // C = Debug: Cannot combine Vowels.*************
                                        combined = c; // Normal
                                        jamoCounter = 0;
                                        wipeString = "";

                                        // Have to save this vowel in case of a single vowel (fill needed)
                                        prevMedJamoChar1 = medJamo[ref];

                                        forgetOldSyllable(); // complete restart of syllable
                                        startNewSyllable();
                                  }

                                break;
                        }
                        // ...


                        // Consonant:
                        // Consider it as a new start in case it is a consonant that cannot be Trail/final
                        JamoChar1 = initJamo[JamoChar3ref]; // This may not always be enough... (bounds!)
                        JamoChar2 = 0x1161; // default
                        JamoChar3 = 0x11a7; // default

                        jamoCounter = 1; // Next, take the *second* Jamo.
                        //combined = c; // Still show what there is to start with
                        //combined = "D" + GKOSChars[JamoChar3ref]; // D = Debug: New Start Consonant ****************
                        combined = GKOSChars[JamoChar3ref]; // Normal
                        wipeString = "";



                }

                //jamoCounter = 0;

        break;


        default:

                //combined = "E" + c; // E = Debug: Default **************
                combined = c; // Normal
                jamoCounter = 0;

        }
        prevCodePoint = codePoint;
        return wipeString + fillString + combined;
}


function forgetOldSyllable() {

        //fixOrphanVowel();

        //prevMedJamoChar1 = 0x1161; // default for single vowel, adding mute symbol

        prevJamoChar1 = 0x1100; // default
        prevJamoChar2 = 0x1161; // default
        prevJamoChar3 = 0x11a7; // default
        prevJamoChar3ref = 0; // default
        previousSyllable = 0;

}

function startNewSyllable() {

        showMixedLayout();

        jamoCounter = 0;
        JamoChar1 = 0x1100; // default
        JamoChar2 = 0x1161; // default
        JamoChar3 = 0x11a7; // default

}

function fixOrphanVowel() {
        wipeString = "";
        fillString = ""; //
        return; // Not in use yet !!! Backspace, Enter etc are still a problem
//		if (prevMedJamoChar1 > 0x1160){ // Previous single vowel exists?
//		fillString = String.valueOf((char) (((0x110b - 0x1100)*21 + (prevMedJamoChar1 - 0x1161))*28 + 0xac00));
//		wipeString = "<";
//		prevMedJamoChar1 = 0x1160; // default
//		}
}

function showVowelLayout() {

        vowelLayoutMode = true;

        GKOSChars[7+320]= "\u3150"; // G
        GKOSChars[8+320]= ""; //
        GKOSChars[9+320]= "\u3159"; // I
        GKOSChars[10+320]= ""; //

        GKOSChars[11+320]= "\u3154"; // K
        GKOSChars[12+320]= ""; //
        GKOSChars[13+320]= "\u315e"; // M
        GKOSChars[14+320]= ""; //

        GKOSChars[15+320]= "\u3158"; // O
        GKOSChars[16+320]= ""; //
        GKOSChars[17+320]= "\u315a"; // Q
        GKOSChars[18+320]= ""; //

        GKOSChars[19+320]= "\u315d"; // S
        GKOSChars[20+320]= ""; //
        GKOSChars[21+320]= "\u315f"; // U
        GKOSChars[22+320]= ""; //

        //GKOSChars[23+320]= "\u3152"; // W 'NEXT'
        GKOSChars[25+320]= "\u3152"; // Y

        GKOSChars[27+320]= "\u3162"; // TH
        GKOSChars[29+320]= "\u3156"; // the

}

function showMixedLayout() {

        vowelLayoutMode = false;

        var k = 320;
        GKOSChars[1+k]= "ㅏ"; // A
        GKOSChars[2+k]= "ㅡ";
        GKOSChars[3+k]= "ㅓ";
        GKOSChars[4+k]= "ㅜ";
        GKOSChars[5+k]= "ㅣ";
        GKOSChars[6+k]= "ㅗ";

        GKOSChars[7+k]= "ㅎ";  // G
        GKOSChars[8+k]= "ㅋ";
        GKOSChars[9+k]= "ㄱ";
        GKOSChars[10+k]= "ㄲ";

        GKOSChars[11+k]= "ㄴ"; // K
        GKOSChars[12+k]= "ㅊ";
        GKOSChars[13+k]= "ㅈ";
        GKOSChars[14+k]= "ㅉ";

        GKOSChars[15+k]= "ㅇ";  //o
        GKOSChars[16+k]= "ㅍ";
        GKOSChars[17+k]= "ㅂ";
        GKOSChars[18+k]= "ㅃ";

        GKOSChars[19+k]= "ㅁ";  //s
        GKOSChars[20+k]= "ㅌ";
        GKOSChars[21+k]= "ㄷ";
        GKOSChars[22+k]= "ㄸ";

        GKOSChars[25+k]= "ㅅ";

        GKOSChars[27+k]= "ㄹ"; //th
        GKOSChars[29+k]= "ㅆ";

}




