
// file id: GText

function addCharacter(character, text, offset, ref, pos) {

    gChar = GSets.GKOSChars[ref + offset]
    var newOffset = offset;

    if (autoRepeat){
        gChar = GSets.GKOSChars[ref + prevOffset]
        newOffset = offset;
    }

    // 0,  64, 128, 192, 256, 320, 384, 448
    // abc Abc ABC  123  SYMB aux  Aux  AUX

    switch (offset)
    {

    case 0: // abc


        if (gChar == "_SYMB"){
            newOffset = 256;  gChar = "";
            break;
        }

        if (gChar == "_123abc"){
            newOffset = 192;  gChar = "";
            numberMode = true;
            break;
        }

        if (gChar == "_Shift"){
            newOffset = 64;  gChar = "";
            break;
        }
        if (gChar == "_Alt"){
            newOffset = 384;  gChar = "";
            break;
        }
        if (gChar == "_Tab"){
            gChar = "        ";
            break;
        }
        break;

    // ...



    case 64: // Abc

        if (gChar == "_Shift"){
            newOffset = 128;  gChar = "";
            break;
        }

        if (gChar == "_SYMB"){
            newOffset = 256;  gChar = "";
            break;
        }

        if (gChar == "_123abc"){
            newOffset = 192;  gChar = "";
            numberMode = true;
            break;
        }
        break;

    case 128: // ABC

        if (gChar == "_Shift"){
            newOffset = 0;  gChar = "";
            // if (useAuxSets){newOffset = 320;}
            break;
        }

        if (gChar == "_SYMB"){
            newOffset = 256;  gChar = "";
            break;
        }

        if (gChar == "_123abc"){
            newOffset = 192;  gChar = "";
            break;
        }
        break;


    case 192: // 123

        if (gChar == "_123abc"){
            newOffset = 0;  gChar = "";
            numberMode = false;
            if (useAuxSets){newOffset = 320;}
            break;
        }

        if (gChar == "_Shift"){ // Number shift = symb
            newOffset = 256;  gChar = "";
            break;
        }
        // pick single chars from parallel set:
        if ((gChar == "_SYMB") && (!useAuxSets)){
            newOffset = numberMode? 0 : 256;
            gChar = "";
            break;
        }
        if ((gChar == "_SYMB") && (useAuxSets)){
            newOffset = numberMode? 320 : 256;
            gChar = "";
            break;
        }


        break;

    case 256: // SYMB

        if (gChar == "_123abc"){
            newOffset = 0;  gChar = "";
            numberMode = false;
            // if (useAuxSets){newOffset = 320;}
            break;
        }
        // ---
        if ((gChar == "_Shift") && (!useAuxSets)){ // Number shift = symb
            if (numberMode){newOffset = 192;} else { newOffset = 64;}
            gChar = "";
            break;
        }
        if ((gChar == "_Shift") && (useAuxSets)){ // Number shift = symb
            if (numberMode){newOffset = 192;} else { newOffset = 384;}
            gChar = "";
            break;
        }
        // ---
        if ((gChar == "_SYMB") && (!useAuxSets)){ // Number shift = symb
            if (numberMode){newOffset = 192;} else { newOffset = 0;}
            gChar = "";
            break;
        }
        if ((gChar == "_SYMB") && (useAuxSets)){ // Number shift = symb
            if (numberMode){newOffset = 192;} else { newOffset = 320;}
            gChar = "";
            break;
        }
        break;

    case 320: // aux

        if (gChar == "_SYMB"){
            newOffset = 256;  gChar = "";
            break;
        }

        if (gChar == "_123abc"){
            newOffset = 192;  gChar = "";
            numberMode = true;
            break;
        }

        if (gChar == "_Shift"){
            newOffset = 384;  gChar = "";
            break;
        }
        if (gChar == "_Alt"){
            newOffset = 0;  gChar = "";
            break;
        }
        if (gChar == "_Tab"){
            gChar = "        ";
            break;
        }
        break;


    case 384: // Aux

        if (gChar == "_Shift"){
            newOffset = 448;  gChar = "";
            break;
        }

        if (gChar == "_SYMB"){
            newOffset = 256;  gChar = "";
            break;
        }

        if (gChar == "_123abc"){
            newOffset = 192;  gChar = "";
            numberMode = true;
            break;
        }

        break;


    case 448: // AUX

        if (gChar == "_Shift"){
            newOffset = 320;  gChar = "";
            break;
        }

        if (gChar == "_SYMB"){
            newOffset = 256;  gChar = "";
            break;
        }

        if (gChar == "_123abc"){
            newOffset = 192;  gChar = "";
            numberMode = true;
            break;
        }

        break;

    default:
        // newOffset = 0;
        break;
    }


    // offset = 128; // test
    // if (gChar == "_BS"){text = ""; gChar = ">"} // test only

    // pos = text.length; // initial cursor position, temp!!!

    // ----- Controls --------

    if (gChar.substring(0,1) == "_")
    {

    if (gChar == "_Left"){pos = handleLeft(text.length, pos); gChar = "";}
    if (gChar == "_Right"){pos = handleRight(text.length, pos); gChar = "";}
    if (gChar == "_Up"){pos = handleUp(text.length, pos); gChar = "";}
    if (gChar == "_Down"){pos = handleDown(text.length, pos); gChar = "";}
    if (gChar == "_WLeft"){pos = handleWLeft(text.length, pos); gChar = "";}
    if (gChar == "_WRight"){pos = handleWRight(text.length, pos); gChar = "";}
    if (gChar == "_Home"){pos = handleHome(text.length, pos); gChar = "";}
    if (gChar == "_End"){pos = handleEnd(text.length, pos); gChar = "";}
    if (gChar == "_PgUp"){pos = handleHome(text.length, pos); gChar = "";}
    if (gChar == "_PgDn"){pos = handleEnd(text.length, pos); gChar = "";}
    if (gChar == "_Esc"){pos = handleEsc(text.length, pos); gChar = "";}
    if (gChar == "_Ctrl"){pos = handleCtrl(text.length, pos); gChar = "";}
    if (gChar == "_Alt"){pos = handleAlt(text.length, pos); gChar = "";}
    if (gChar == "_Del"){
            if (text.length > pos){
                text = text.substring(0, pos) + text.substring(pos + 1);
                gChar = "";
            } else {gChar = "";} // do nothing if at start
    }
    if (gChar == "_Enter"){
        text = text.substring(0, pos) + "\n" + text.substring(pos, text.length);
        gChar = ""; pos += 1;
        }

    if (gChar == "_BS"){
        if ((text.length > 0) && (pos > 0)){
            text = text.substring(0, pos - 1) + text.substring(pos, text.length);
            gChar = "";
            pos = pos - 1;
            return {text:text, offset:newOffset, pos:pos}
        } else {gChar = "";} // do nothing if at start
    }




    } // end of _....

     // ------------


    // Fix some accents:

    if (isAccent(gChar)){
        // gChar = getCombinedCharacter(prevChar, gChar);
        if ((text.length > 0) && (pos > 0)){ // insert backspace + the new accented character
            gChar = getCombinedCharacter(text.substring(pos - 1, pos), gChar);
            text = text.substring(0, pos - 1) + gChar + text.substring(pos, text.length);
            gChar = "";
            return {text:text, offset:newOffset, pos:pos}
        } else {gChar = "";} // do nothing if at start (nothing before accent)

    }



    // ----- Clean missed modifiers ----

    if ((gChar.substring(0,1) == "_") && (gChar != "_")){gChar = "";}



    // 0,  64, 128, 192, 256, 320, 384, 448
    // abc Abc ABC  123  SYMB aux  Aux  AUX

    // always reset modifiers SYMB and Shift:

    if (!useAuxSets){ // basic sets in use

        if (((offset == 256) || (offset == 64) || (offset == 384)) && (gChar !== "")){
            newOffset = 0; labelAbc = "abc";}
    } else { // aux sets in use
            if (((offset == 256) || (offset == 64) || (offset == 384)) && (gChar !== "")){
                newOffset = 320; labelAbc = auxLabel1;}
    }
    // Correction to the previous is the special case when we are in numberMode:
    if (numberMode){
        if ( (offset == 256 ) || (offset === 0) || (offset == 320) || (offset == 64) || (offset == 384) ){
            // return to 123 mode from SYMB/abc/Abc/aux/Aux if in numberMode
            newOffset = 192; labelAbc = "123";
        }
    }


    if (pos <= text.length){
        text = text.substring(0, pos) + gChar + text.substring(pos, text.length);
    } else {text += gChar;}



    pos = pos + gChar.length;
    return {text:text, offset:newOffset, pos:pos}


}

// ================================================================

function handleLeft(length, pos){
    if ((length > 1) && (pos > 0)){
        pos -=  1;
    }
    return pos;
}

function handleRight(length, pos){
    if (pos < length){
        pos +=  1;
    }
    return pos;
}

function handleUp(length, pos){
    var a = parseInt(length/linecount);
    if (length > a){
        pos -= a + 1;
    } else {pos = 0;
    }
    return pos;
}

function handleDown(length, pos){
    var a = parseInt(length/linecount);
    if (length > a){
        pos += a + 1;
    } else {pos = length;
    }
    return pos;
}

function handleWLeft(length, pos){
    if (length > 10){
        pos -=  10;
    } else {pos = 0;
    }
    return pos;
}

function handleWRight(length, pos){
    if ((length - pos) > 10){
        pos +=  10;
    } else {pos = length;
    }
    return pos;
}


function handleHome(length, pos){
    pos = 0;
    return pos;
}

function handleEnd(length, pos){
    pos = length;
    return pos;
}
function handleEsc(length, pos){

    return pos;
}
function handleCtrl(length, pos){

    return pos;
}
function handleAlt(length, pos){

    return pos;
}


// ------------------------------------------


        // function getCombinedCharacter(String c, String accent) { // Android version
function getCombinedCharacter(c, accent) {

        var isUpperCase = !(c == c.toLowerCase());

                var combined = c;

                c = c.toLowerCase();

                if ("ˆ" == accent) { // Originally in beta: ^
                        if ("a" == c)
                                combined = "â";
                        else if ("e" == c)
                                combined = "ê";
                        else if ("i" == c)
                                combined = "î";
                        else if ("o" == c)
                                combined = "ô";
                        else if ("u" == c)
                                combined = "û";
                        else if (" " == c)
                                combined = "ˆ";
                }

                else if ("ˇ" == accent) {
                        if ("a" == c)
                                combined = "ǎ";
                        else if ("e" == c)
                                combined = "ě";
                        else if ("i" == c)
                                combined = "ǐ";
                        else if ("o" == c)
                                combined = "ǒ";
                        else if ("u" == c)
                                combined = "ǔ";
                        else if ("s" == c)
                                combined = "š";
                        else if ("z" == c)
                                combined = "ž";
                        else if (" " == c)
                                combined = "ˇ";

                }

                else if ("`" == accent) {
                        if ("a" == c)
                                combined = "à";
                        else if ("e" == c)
                                combined = "è";
                        else if ("i" == c)
                                combined = "ì";
                        else if ("o" == c)
                                combined = "ò";
                        else if ("u" == c)
                                combined = "ù";
                        else if (" " == c)
                                combined = "`";
                }

                else if ("´" == accent) {
                        if ("a" == c)
                                combined = "á";
                        else if ("e" == c)
                                combined = "é";
                        else if ("i" == c)
                                combined = "í";
                        else if ("o" == c)
                                combined = "ó";
                        else if ("u" == c)
                                combined = "ú";
                        else if (" " == c)
                                combined = "´";
                }
                else if ("~" == accent) {
                        if ("a" == c)
                                combined = "ã";
                        else if ("e" == c)
                                combined = "ẽ";
                        else if ("i" == c)
                                combined = "ĩ";
                        else if ("o" == c)
                                combined = "õ";
                        else if ("u" == c)
                                combined = "ũ";
                        else if ("n" == c)
                                combined = "ñ";
                        else if (" " == c)
                                combined = "~";
                }

                else if ("¨" == accent) {
                       // if ("¨" == accent) {
                        if ("a" == c)
                                combined = "ä";
                        else if ("e" == c)
                                combined = "ë";
                        else if ("е" == c)
                                combined = "ë";// Russian е != e
                        else if ("i" == c)
                                combined = "ï";
                        else if ("o" == c)
                                combined = "ö";
                        else if ("u" == c)
                                combined = "ü";
                        else if (" " == c)
                                combined = "¨";
                }

                 return (isUpperCase ? combined.toUpperCase() : combined);
                // return combined;
}


function isAccent(c) {
                var gAccents = "`´~¨ˆˇ";
                return (gAccents.indexOf(c) != -1); // contains(c)  is not part of javascript
}

