import QtQuick 1.0
import Multitouch 1.0
import com.nokia.meego 1.1

// Item {
Rectangle {
    id: root
    x: 0
    y: 0

    width: 854 // parent.width
    height: 480 // parent.height
    color: "darkgrey"

    property variant touchPoints: multitouch.touchPoints

    Repeater {
        id: repeater
        anchors.fill: parent
        model: touchPoints.length

        Rectangle {
            color: index == 0 ? "blue" : "red"
            x: touchPoints[index].x - width/2
            y: touchPoints[index].y - height/2
            width: 80
            height: 80
            radius: 40
        }
    }

    Text {
        id: textfield
        text: "Touch points: "+touchPoints.length
        anchors.centerIn: parent
    }
}
